package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxizpdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_ExtOfXIZPDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxizpdescTbl _RibExtofxizpdescTblFactory = new RibExtofxizpdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxizpdescTblFactory; }
  /* constructors */
  public RibExtofxizpdescTbl()
  {
    this((RibExtofxizpdescRec[])null);
  }

  public RibExtofxizpdescTbl(RibExtofxizpdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxizpdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__schemaName!=null) return _array.toDatum(c,__schemaName + "." + _SQL_NAME);
    return _array.toDatum(c, _SQL_NAME);
  }
  private String __schemaName = null;
  public void __setSchemaName(String schemaName) { __schemaName = schemaName; }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibExtofxizpdescTbl a = new RibExtofxizpdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxizpdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxizpdescRec[] getArray() throws SQLException
  {
    return (RibExtofxizpdescRec[]) _array.getObjectArray(
      new RibExtofxizpdescRec[_array.length()]);
  }

  public RibExtofxizpdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxizpdescRec[]) _array.getObjectArray(index,
      new RibExtofxizpdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxizpdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxizpdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxizpdescRec getElement(long index) throws SQLException
  {
    return (RibExtofxizpdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxizpdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
