package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXitemseasonTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_XItemSeason_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXitemseasonTbl _RibXitemseasonTblFactory = new RibXitemseasonTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemseasonTblFactory; }
  /* constructors */
  public RibXitemseasonTbl()
  {
    this((RibXitemseasonRec[])null);
  }

  public RibXitemseasonTbl(RibXitemseasonRec[] a)
  {
    _array = new MutableArray(2002, a, RibXitemseasonRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__schemaName!=null) return _array.toDatum(c,__schemaName + "." + _SQL_NAME);
    return _array.toDatum(c, _SQL_NAME);
  }
  private String __schemaName = null;
  public void __setSchemaName(String schemaName) { __schemaName = schemaName; }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibXitemseasonTbl a = new RibXitemseasonTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXitemseasonRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXitemseasonRec[] getArray() throws SQLException
  {
    return (RibXitemseasonRec[]) _array.getObjectArray(
      new RibXitemseasonRec[_array.length()]);
  }

  public RibXitemseasonRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXitemseasonRec[]) _array.getObjectArray(index,
      new RibXitemseasonRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXitemseasonRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXitemseasonRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXitemseasonRec getElement(long index) throws SQLException
  {
    return (RibXitemseasonRec) _array.getObjectElement(index);
  }

  public void setElement(RibXitemseasonRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
