package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibXitmsupctymfrdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RIB_XItmSupCtyMfrDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibXitmsupctymfrdescRecRef _RibXitmsupctymfrdescRecRefFactory = new RibXitmsupctymfrdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibXitmsupctymfrdescRecRefFactory; }
  /* constructor */
  public RibXitmsupctymfrdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibXitmsupctymfrdescRecRef r = new RibXitmsupctymfrdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibXitmsupctymfrdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibXitmsupctymfrdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibXitmsupctymfrdescRecRef: "+exn.toString()); }
  }

  public RibXitmsupctymfrdescRec getValue() throws SQLException
  {
     return (RibXitmsupctymfrdescRec)RibXitmsupctymfrdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibXitmsupctymfrdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
