
package oracle.retail.microapps.map.config;

import javax.xml.bind.annotation.XmlRegistry;


/**
 * This object contains factory methods for each 
 * Java content interface and Java element interface 
 * generated in the oracle.retail.microapps.map.config package. 
 * <p>An ObjectFactory allows you to programatically 
 * construct new instances of the Java representation 
 * for XML content. The Java representation of XML 
 * content can consist of schema derived interfaces 
 * and classes representing the binding of schema 
 * type definitions, element declarations and model 
 * groups.  Factory methods for each of these are 
 * provided in this class.
 * 
 */
@XmlRegistry
public class ObjectFactory {


    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: oracle.retail.microapps.map.config
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link MapConfig }
     * 
     */
    public MapConfig createMapConfig() {
        return new MapConfig();
    }

    /**
     * Create an instance of {@link MapConfig.Themes }
     * 
     */
    public MapConfig.Themes createMapConfigThemes() {
        return new MapConfig.Themes();
    }

    /**
     * Create an instance of {@link MapConfig.Themes.Theme }
     * 
     */
    public MapConfig.Themes.Theme createMapConfigThemesTheme() {
        return new MapConfig.Themes.Theme();
    }

    /**
     * Create an instance of {@link MapConfig.Themes.Theme.LaunchableApps }
     * 
     */
    public MapConfig.Themes.Theme.LaunchableApps createMapConfigThemesThemeLaunchableApps() {
        return new MapConfig.Themes.Theme.LaunchableApps();
    }

    /**
     * Create an instance of {@link MapConfig.Themes.Theme.LaunchableApps.App }
     * 
     */
    public MapConfig.Themes.Theme.LaunchableApps.App createMapConfigThemesThemeLaunchableAppsApp() {
        return new MapConfig.Themes.Theme.LaunchableApps.App();
    }

    /**
     * Create an instance of {@link MapConfig.Themes.Theme.BusinessDataMapping }
     * 
     */
    public MapConfig.Themes.Theme.BusinessDataMapping createMapConfigThemesThemeBusinessDataMapping() {
        return new MapConfig.Themes.Theme.BusinessDataMapping();
    }

    /**
     * Create an instance of {@link MapConfig.Themes.Theme.SpatialDataMapping }
     * 
     */
    public MapConfig.Themes.Theme.SpatialDataMapping createMapConfigThemesThemeSpatialDataMapping() {
        return new MapConfig.Themes.Theme.SpatialDataMapping();
    }

    /**
     * Create an instance of {@link MapConfig.Themes.Theme.LaunchableApps.App.Parameter }
     * 
     */
    public MapConfig.Themes.Theme.LaunchableApps.App.Parameter createMapConfigThemesThemeLaunchableAppsAppParameter() {
        return new MapConfig.Themes.Theme.LaunchableApps.App.Parameter();
    }

    /**
     * Create an instance of {@link MapConfig.Themes.Theme.BusinessDataMapping.Data }
     * 
     */
    public MapConfig.Themes.Theme.BusinessDataMapping.Data createMapConfigThemesThemeBusinessDataMappingData() {
        return new MapConfig.Themes.Theme.BusinessDataMapping.Data();
    }

}
