package oracle.retail.microapps.map;

import oracle.retail.microapps.map.am.applicationModule.MapDataAMFixture;
import oracle.retail.microapps.map.am.view.ItemSales1VO.ItemSales1VOTest;
import oracle.retail.microapps.map.am.view.ItemTransactions1VO.ItemTransactions1VOTest;

import oracle.retail.microapps.map.config.MapConfigReaderTest;

import oracle.retail.microapps.map.managed.helper.InContextAppDispatcherTest;

import org.junit.*;
import org.junit.runner.RunWith;
import org.junit.runners.Suite;

@RunWith(Suite.class)
@Suite.SuiteClasses( { ItemSales1VOTest.class, 
                       ItemTransactions1VOTest.class,
                       MapConfigReaderTest.class,
                       InContextAppDispatcherTest.class})
public class AllMapDataTests {
    @BeforeClass
    public static void setUp() {
    }

    @AfterClass
    public static void tearDown() throws Exception {
        MapDataAMFixture.getInstance().release();
    }
}
