package oracle.retail.microapps.order.create.am;

import oracle.retail.microapps.order.create.am.applicationModule.CreateOrderAMFixture;
import oracle.retail.microapps.order.create.am.applicationModule.CreateOrderAMTest;
import oracle.retail.microapps.order.create.am.view.ItemsVO1VO.ItemsVO1VOTest;
import oracle.retail.microapps.order.create.am.view.LocationVO1VO.LocationVO1VOTest;
import oracle.retail.microapps.order.create.am.view.SystemOptionsVO1VO.SystemOptionsVO1VOTest;
import oracle.retail.microapps.order.create.am.view.VSupMsobNVO1VO.VSupMsobNVO1VOTest;
import oracle.retail.microapps.order.create.am.view.VSupMsobYVO1VO.VSupMsobYVO1VOTest;

import org.junit.*;
import org.junit.runner.RunWith;
import org.junit.runners.Suite;

@RunWith(Suite.class)
@Suite.SuiteClasses( { VSupMsobYVO1VOTest.class, VSupMsobNVO1VOTest.class,
                       SystemOptionsVO1VOTest.class, LocationVO1VOTest.class,
                       ItemsVO1VOTest.class, CreateOrderAMTest.class })
public class AllCreateOrderTests {
    @BeforeClass
    public static void setUp() {
    }

    @AfterClass
    public static void tearDown() throws Exception {
        CreateOrderAMFixture.getInstance().release();
    }
}
