package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxiscdimdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXISCDimDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxiscdimdescTbl _RibBrxiscdimdescTblFactory = new RibBrxiscdimdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxiscdimdescTblFactory; }
  /* constructors */
  public RibBrxiscdimdescTbl()
  {
    this((RibBrxiscdimdescRec[])null);
  }

  public RibBrxiscdimdescTbl(RibBrxiscdimdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxiscdimdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxiscdimdescTbl a = new RibBrxiscdimdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxiscdimdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxiscdimdescRec[] getArray() throws SQLException
  {
    return (RibBrxiscdimdescRec[]) _array.getObjectArray(
      new RibBrxiscdimdescRec[_array.length()]);
  }

  public RibBrxiscdimdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxiscdimdescRec[]) _array.getObjectArray(index,
      new RibBrxiscdimdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxiscdimdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxiscdimdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxiscdimdescRec getElement(long index) throws SQLException
  {
    return (RibBrxiscdimdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxiscdimdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
