package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibBrxitembomdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_BrXItemBOMDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibBrxitembomdescRecRef _RibBrxitembomdescRecRefFactory = new RibBrxitembomdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitembomdescRecRefFactory; }
  /* constructor */
  public RibBrxitembomdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxitembomdescRecRef r = new RibBrxitembomdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibBrxitembomdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibBrxitembomdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibBrxitembomdescRecRef: "+exn.toString()); }
  }

  public RibBrxitembomdescRec getValue() throws SQLException
  {
     return (RibBrxitembomdescRec) RibBrxitembomdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibBrxitembomdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
