package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxitembomdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXItemBOMDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxitembomdescTbl _RibBrxitembomdescTblFactory = new RibBrxitembomdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitembomdescTblFactory; }
  /* constructors */
  public RibBrxitembomdescTbl()
  {
    this((RibBrxitembomdescRec[])null);
  }

  public RibBrxitembomdescTbl(RibBrxitembomdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxitembomdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxitembomdescTbl a = new RibBrxitembomdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxitembomdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxitembomdescRec[] getArray() throws SQLException
  {
    return (RibBrxitembomdescRec[]) _array.getObjectArray(
      new RibBrxitembomdescRec[_array.length()]);
  }

  public RibBrxitembomdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxitembomdescRec[]) _array.getObjectArray(index,
      new RibBrxitembomdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxitembomdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxitembomdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxitembomdescRec getElement(long index) throws SQLException
  {
    return (RibBrxitembomdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxitembomdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
