package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxitemseasonTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXItemSeason_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxitemseasonTbl _RibBrxitemseasonTblFactory = new RibBrxitemseasonTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitemseasonTblFactory; }
  /* constructors */
  public RibBrxitemseasonTbl()
  {
    this((RibBrxitemseasonRec[])null);
  }

  public RibBrxitemseasonTbl(RibBrxitemseasonRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxitemseasonRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxitemseasonTbl a = new RibBrxitemseasonTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxitemseasonRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxitemseasonRec[] getArray() throws SQLException
  {
    return (RibBrxitemseasonRec[]) _array.getObjectArray(
      new RibBrxitemseasonRec[_array.length()]);
  }

  public RibBrxitemseasonRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxitemseasonRec[]) _array.getObjectArray(index,
      new RibBrxitemseasonRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxitemseasonRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxitemseasonRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxitemseasonRec getElement(long index) throws SQLException
  {
    return (RibBrxitemseasonRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxitemseasonRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
