package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxitemudadtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXItemUDADtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxitemudadtlTbl _RibBrxitemudadtlTblFactory = new RibBrxitemudadtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitemudadtlTblFactory; }
  /* constructors */
  public RibBrxitemudadtlTbl()
  {
    this((RibBrxitemudadtlRec[])null);
  }

  public RibBrxitemudadtlTbl(RibBrxitemudadtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxitemudadtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxitemudadtlTbl a = new RibBrxitemudadtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxitemudadtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxitemudadtlRec[] getArray() throws SQLException
  {
    return (RibBrxitemudadtlRec[]) _array.getObjectArray(
      new RibBrxitemudadtlRec[_array.length()]);
  }

  public RibBrxitemudadtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxitemudadtlRec[]) _array.getObjectArray(index,
      new RibBrxitemudadtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxitemudadtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxitemudadtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxitemudadtlRec getElement(long index) throws SQLException
  {
    return (RibBrxitemudadtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxitemudadtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
