package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxizpdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXIZPDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxizpdescTbl _RibBrxizpdescTblFactory = new RibBrxizpdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxizpdescTblFactory; }
  /* constructors */
  public RibBrxizpdescTbl()
  {
    this((RibBrxizpdescRec[])null);
  }

  public RibBrxizpdescTbl(RibBrxizpdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxizpdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxizpdescTbl a = new RibBrxizpdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxizpdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxizpdescRec[] getArray() throws SQLException
  {
    return (RibBrxizpdescRec[]) _array.getObjectArray(
      new RibBrxizpdescRec[_array.length()]);
  }

  public RibBrxizpdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxizpdescRec[]) _array.getObjectArray(index,
      new RibBrxizpdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxizpdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxizpdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxizpdescRec getElement(long index) throws SQLException
  {
    return (RibBrxizpdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxizpdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
