package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxtsfdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXTsfDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxtsfdescTbl _RibBrxtsfdescTblFactory = new RibBrxtsfdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxtsfdescTblFactory; }
  /* constructors */
  public RibBrxtsfdescTbl()
  {
    this((RibBrxtsfdescRec[])null);
  }

  public RibBrxtsfdescTbl(RibBrxtsfdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxtsfdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxtsfdescTbl a = new RibBrxtsfdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxtsfdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxtsfdescRec[] getArray() throws SQLException
  {
    return (RibBrxtsfdescRec[]) _array.getObjectArray(
      new RibBrxtsfdescRec[_array.length()]);
  }

  public RibBrxtsfdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxtsfdescRec[]) _array.getObjectArray(index,
      new RibBrxtsfdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxtsfdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxtsfdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxtsfdescRec getElement(long index) throws SQLException
  {
    return (RibBrxtsfdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxtsfdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
