package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxtsfdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXTsfDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxtsfdtlTbl _RibBrxtsfdtlTblFactory = new RibBrxtsfdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxtsfdtlTblFactory; }
  /* constructors */
  public RibBrxtsfdtlTbl()
  {
    this((RibBrxtsfdtlRec[])null);
  }

  public RibBrxtsfdtlTbl(RibBrxtsfdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxtsfdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxtsfdtlTbl a = new RibBrxtsfdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxtsfdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxtsfdtlRec[] getArray() throws SQLException
  {
    return (RibBrxtsfdtlRec[]) _array.getObjectArray(
      new RibBrxtsfdtlRec[_array.length()]);
  }

  public RibBrxtsfdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxtsfdtlRec[]) _array.getObjectArray(index,
      new RibBrxtsfdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxtsfdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxtsfdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxtsfdtlRec getElement(long index) throws SQLException
  {
    return (RibBrxtsfdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxtsfdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
