package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxisclocdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXISCLocDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxisclocdescTbl _RibEofbrxisclocdescTblFactory = new RibEofbrxisclocdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxisclocdescTblFactory; }
  /* constructors */
  public RibEofbrxisclocdescTbl()
  {
    this((RibEofbrxisclocdescRec[])null);
  }

  public RibEofbrxisclocdescTbl(RibEofbrxisclocdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxisclocdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxisclocdescTbl a = new RibEofbrxisclocdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxisclocdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxisclocdescRec[] getArray() throws SQLException
  {
    return (RibEofbrxisclocdescRec[]) _array.getObjectArray(
      new RibEofbrxisclocdescRec[_array.length()]);
  }

  public RibEofbrxisclocdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxisclocdescRec[]) _array.getObjectArray(index,
      new RibEofbrxisclocdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxisclocdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxisclocdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxisclocdescRec getElement(long index) throws SQLException
  {
    return (RibEofbrxisclocdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxisclocdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
