package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibEofbrxitemctrydescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_EOfBrXItemCtryDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibEofbrxitemctrydescRecRef _RibEofbrxitemctrydescRecRefFactory = new RibEofbrxitemctrydescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxitemctrydescRecRefFactory; }
  /* constructor */
  public RibEofbrxitemctrydescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxitemctrydescRecRef r = new RibEofbrxitemctrydescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibEofbrxitemctrydescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibEofbrxitemctrydescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibEofbrxitemctrydescRecRef: "+exn.toString()); }
  }

  public RibEofbrxitemctrydescRec getValue() throws SQLException
  {
     return (RibEofbrxitemctrydescRec) RibEofbrxitemctrydescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibEofbrxitemctrydescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
