package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxitemctrydescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXItemCtryDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxitemctrydescTbl _RibEofbrxitemctrydescTblFactory = new RibEofbrxitemctrydescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxitemctrydescTblFactory; }
  /* constructors */
  public RibEofbrxitemctrydescTbl()
  {
    this((RibEofbrxitemctrydescRec[])null);
  }

  public RibEofbrxitemctrydescTbl(RibEofbrxitemctrydescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxitemctrydescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxitemctrydescTbl a = new RibEofbrxitemctrydescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxitemctrydescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxitemctrydescRec[] getArray() throws SQLException
  {
    return (RibEofbrxitemctrydescRec[]) _array.getObjectArray(
      new RibEofbrxitemctrydescRec[_array.length()]);
  }

  public RibEofbrxitemctrydescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxitemctrydescRec[]) _array.getObjectArray(index,
      new RibEofbrxitemctrydescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxitemctrydescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxitemctrydescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxitemctrydescRec getElement(long index) throws SQLException
  {
    return (RibEofbrxitemctrydescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxitemctrydescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
