package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxitemdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXItemDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxitemdescTbl _RibEofbrxitemdescTblFactory = new RibEofbrxitemdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxitemdescTblFactory; }
  /* constructors */
  public RibEofbrxitemdescTbl()
  {
    this((RibEofbrxitemdescRec[])null);
  }

  public RibEofbrxitemdescTbl(RibEofbrxitemdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxitemdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxitemdescTbl a = new RibEofbrxitemdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxitemdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxitemdescRec[] getArray() throws SQLException
  {
    return (RibEofbrxitemdescRec[]) _array.getObjectArray(
      new RibEofbrxitemdescRec[_array.length()]);
  }

  public RibEofbrxitemdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxitemdescRec[]) _array.getObjectArray(index,
      new RibEofbrxitemdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxitemdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxitemdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxitemdescRec getElement(long index) throws SQLException
  {
    return (RibEofbrxitemdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxitemdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
