package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxitemseasonTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXItemSeason_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxitemseasonTbl _RibEofbrxitemseasonTblFactory = new RibEofbrxitemseasonTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxitemseasonTblFactory; }
  /* constructors */
  public RibEofbrxitemseasonTbl()
  {
    this((RibEofbrxitemseasonRec[])null);
  }

  public RibEofbrxitemseasonTbl(RibEofbrxitemseasonRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxitemseasonRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxitemseasonTbl a = new RibEofbrxitemseasonTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxitemseasonRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxitemseasonRec[] getArray() throws SQLException
  {
    return (RibEofbrxitemseasonRec[]) _array.getObjectArray(
      new RibEofbrxitemseasonRec[_array.length()]);
  }

  public RibEofbrxitemseasonRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxitemseasonRec[]) _array.getObjectArray(index,
      new RibEofbrxitemseasonRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxitemseasonRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxitemseasonRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxitemseasonRec getElement(long index) throws SQLException
  {
    return (RibEofbrxitemseasonRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxitemseasonRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
