package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxitemvatdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXItemVATDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxitemvatdescTbl _RibEofbrxitemvatdescTblFactory = new RibEofbrxitemvatdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxitemvatdescTblFactory; }
  /* constructors */
  public RibEofbrxitemvatdescTbl()
  {
    this((RibEofbrxitemvatdescRec[])null);
  }

  public RibEofbrxitemvatdescTbl(RibEofbrxitemvatdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxitemvatdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxitemvatdescTbl a = new RibEofbrxitemvatdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxitemvatdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxitemvatdescRec[] getArray() throws SQLException
  {
    return (RibEofbrxitemvatdescRec[]) _array.getObjectArray(
      new RibEofbrxitemvatdescRec[_array.length()]);
  }

  public RibEofbrxitemvatdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxitemvatdescRec[]) _array.getObjectArray(index,
      new RibEofbrxitemvatdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxitemvatdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxitemvatdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxitemvatdescRec getElement(long index) throws SQLException
  {
    return (RibEofbrxitemvatdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxitemvatdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
