package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxitemctrydescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXItemCtryDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxitemctrydescTbl _RibEofinxitemctrydescTblFactory = new RibEofinxitemctrydescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxitemctrydescTblFactory; }
  /* constructors */
  public RibEofinxitemctrydescTbl()
  {
    this((RibEofinxitemctrydescRec[])null);
  }

  public RibEofinxitemctrydescTbl(RibEofinxitemctrydescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxitemctrydescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxitemctrydescTbl a = new RibEofinxitemctrydescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxitemctrydescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxitemctrydescRec[] getArray() throws SQLException
  {
    return (RibEofinxitemctrydescRec[]) _array.getObjectArray(
      new RibEofinxitemctrydescRec[_array.length()]);
  }

  public RibEofinxitemctrydescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxitemctrydescRec[]) _array.getObjectArray(index,
      new RibEofinxitemctrydescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxitemctrydescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxitemctrydescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxitemctrydescRec getElement(long index) throws SQLException
  {
    return (RibEofinxitemctrydescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxitemctrydescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
