package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxitemdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXItemDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxitemdescTbl _RibEofinxitemdescTblFactory = new RibEofinxitemdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxitemdescTblFactory; }
  /* constructors */
  public RibEofinxitemdescTbl()
  {
    this((RibEofinxitemdescRec[])null);
  }

  public RibEofinxitemdescTbl(RibEofinxitemdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxitemdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxitemdescTbl a = new RibEofinxitemdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxitemdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxitemdescRec[] getArray() throws SQLException
  {
    return (RibEofinxitemdescRec[]) _array.getObjectArray(
      new RibEofinxitemdescRec[_array.length()]);
  }

  public RibEofinxitemdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxitemdescRec[]) _array.getObjectArray(index,
      new RibEofinxitemdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxitemdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxitemdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxitemdescRec getElement(long index) throws SQLException
  {
    return (RibEofinxitemdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxitemdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
