package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxitemseasonTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXItemSeason_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxitemseasonTbl _RibEofinxitemseasonTblFactory = new RibEofinxitemseasonTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxitemseasonTblFactory; }
  /* constructors */
  public RibEofinxitemseasonTbl()
  {
    this((RibEofinxitemseasonRec[])null);
  }

  public RibEofinxitemseasonTbl(RibEofinxitemseasonRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxitemseasonRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxitemseasonTbl a = new RibEofinxitemseasonTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxitemseasonRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxitemseasonRec[] getArray() throws SQLException
  {
    return (RibEofinxitemseasonRec[]) _array.getObjectArray(
      new RibEofinxitemseasonRec[_array.length()]);
  }

  public RibEofinxitemseasonRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxitemseasonRec[]) _array.getObjectArray(index,
      new RibEofinxitemseasonRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxitemseasonRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxitemseasonRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxitemseasonRec getElement(long index) throws SQLException
  {
    return (RibEofinxitemseasonRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxitemseasonRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
