package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxitemsupdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXItemSupDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxitemsupdescTbl _RibEofinxitemsupdescTblFactory = new RibEofinxitemsupdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxitemsupdescTblFactory; }
  /* constructors */
  public RibEofinxitemsupdescTbl()
  {
    this((RibEofinxitemsupdescRec[])null);
  }

  public RibEofinxitemsupdescTbl(RibEofinxitemsupdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxitemsupdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxitemsupdescTbl a = new RibEofinxitemsupdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxitemsupdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxitemsupdescRec[] getArray() throws SQLException
  {
    return (RibEofinxitemsupdescRec[]) _array.getObjectArray(
      new RibEofinxitemsupdescRec[_array.length()]);
  }

  public RibEofinxitemsupdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxitemsupdescRec[]) _array.getObjectArray(index,
      new RibEofinxitemsupdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxitemsupdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxitemsupdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxitemsupdescRec getElement(long index) throws SQLException
  {
    return (RibEofinxitemsupdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxitemsupdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
