package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxtsfdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXTsfDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxtsfdescTbl _RibEofinxtsfdescTblFactory = new RibEofinxtsfdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxtsfdescTblFactory; }
  /* constructors */
  public RibEofinxtsfdescTbl()
  {
    this((RibEofinxtsfdescRec[])null);
  }

  public RibEofinxtsfdescTbl(RibEofinxtsfdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxtsfdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxtsfdescTbl a = new RibEofinxtsfdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxtsfdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxtsfdescRec[] getArray() throws SQLException
  {
    return (RibEofinxtsfdescRec[]) _array.getObjectArray(
      new RibEofinxtsfdescRec[_array.length()]);
  }

  public RibEofinxtsfdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxtsfdescRec[]) _array.getObjectArray(index,
      new RibEofinxtsfdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxtsfdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxtsfdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxtsfdescRec getElement(long index) throws SQLException
  {
    return (RibEofinxtsfdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxtsfdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
