package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxitemcostdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_ExtOfXItemCostDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxitemcostdescTbl _RibExtofxitemcostdescTblFactory = new RibExtofxitemcostdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemcostdescTblFactory; }
  /* constructors */
  public RibExtofxitemcostdescTbl()
  {
    this((RibExtofxitemcostdescRec[])null);
  }

  public RibExtofxitemcostdescTbl(RibExtofxitemcostdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxitemcostdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibExtofxitemcostdescTbl a = new RibExtofxitemcostdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxitemcostdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxitemcostdescRec[] getArray() throws SQLException
  {
    return (RibExtofxitemcostdescRec[]) _array.getObjectArray(
      new RibExtofxitemcostdescRec[_array.length()]);
  }

  public RibExtofxitemcostdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxitemcostdescRec[]) _array.getObjectArray(index,
      new RibExtofxitemcostdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxitemcostdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxitemcostdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxitemcostdescRec getElement(long index) throws SQLException
  {
    return (RibExtofxitemcostdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxitemcostdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
