package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxtsfdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_ExtOfXTsfDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxtsfdtlTbl _RibExtofxtsfdtlTblFactory = new RibExtofxtsfdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxtsfdtlTblFactory; }
  /* constructors */
  public RibExtofxtsfdtlTbl()
  {
    this((RibExtofxtsfdtlRec[])null);
  }

  public RibExtofxtsfdtlTbl(RibExtofxtsfdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxtsfdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibExtofxtsfdtlTbl a = new RibExtofxtsfdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxtsfdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxtsfdtlRec[] getArray() throws SQLException
  {
    return (RibExtofxtsfdtlRec[]) _array.getObjectArray(
      new RibExtofxtsfdtlRec[_array.length()]);
  }

  public RibExtofxtsfdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxtsfdtlRec[]) _array.getObjectArray(index,
      new RibExtofxtsfdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxtsfdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxtsfdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxtsfdtlRec getElement(long index) throws SQLException
  {
    return (RibExtofxtsfdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxtsfdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
