package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxiscdimdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXISCDimDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxiscdimdescTbl _RibInxiscdimdescTblFactory = new RibInxiscdimdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxiscdimdescTblFactory; }
  /* constructors */
  public RibInxiscdimdescTbl()
  {
    this((RibInxiscdimdescRec[])null);
  }

  public RibInxiscdimdescTbl(RibInxiscdimdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxiscdimdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxiscdimdescTbl a = new RibInxiscdimdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxiscdimdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxiscdimdescRec[] getArray() throws SQLException
  {
    return (RibInxiscdimdescRec[]) _array.getObjectArray(
      new RibInxiscdimdescRec[_array.length()]);
  }

  public RibInxiscdimdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxiscdimdescRec[]) _array.getObjectArray(index,
      new RibInxiscdimdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxiscdimdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxiscdimdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxiscdimdescRec getElement(long index) throws SQLException
  {
    return (RibInxiscdimdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxiscdimdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
