package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxisclocdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXISCLocDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxisclocdescTbl _RibInxisclocdescTblFactory = new RibInxisclocdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxisclocdescTblFactory; }
  /* constructors */
  public RibInxisclocdescTbl()
  {
    this((RibInxisclocdescRec[])null);
  }

  public RibInxisclocdescTbl(RibInxisclocdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxisclocdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxisclocdescTbl a = new RibInxisclocdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxisclocdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxisclocdescRec[] getArray() throws SQLException
  {
    return (RibInxisclocdescRec[]) _array.getObjectArray(
      new RibInxisclocdescRec[_array.length()]);
  }

  public RibInxisclocdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxisclocdescRec[]) _array.getObjectArray(index,
      new RibInxisclocdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxisclocdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxisclocdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxisclocdescRec getElement(long index) throws SQLException
  {
    return (RibInxisclocdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxisclocdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
