package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibInxitembomdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_InXItemBOMDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibInxitembomdescRecRef _RibInxitembomdescRecRefFactory = new RibInxitembomdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitembomdescRecRefFactory; }
  /* constructor */
  public RibInxitembomdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitembomdescRecRef r = new RibInxitembomdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibInxitembomdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibInxitembomdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibInxitembomdescRecRef: "+exn.toString()); }
  }

  public RibInxitembomdescRec getValue() throws SQLException
  {
     return (RibInxitembomdescRec) RibInxitembomdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibInxitembomdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
