package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxitembomdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXItemBOMDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxitembomdescTbl _RibInxitembomdescTblFactory = new RibInxitembomdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitembomdescTblFactory; }
  /* constructors */
  public RibInxitembomdescTbl()
  {
    this((RibInxitembomdescRec[])null);
  }

  public RibInxitembomdescTbl(RibInxitembomdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxitembomdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitembomdescTbl a = new RibInxitembomdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxitembomdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxitembomdescRec[] getArray() throws SQLException
  {
    return (RibInxitembomdescRec[]) _array.getObjectArray(
      new RibInxitembomdescRec[_array.length()]);
  }

  public RibInxitembomdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxitembomdescRec[]) _array.getObjectArray(index,
      new RibInxitembomdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxitembomdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxitembomdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxitembomdescRec getElement(long index) throws SQLException
  {
    return (RibInxitembomdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxitembomdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
