package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibInxitemctrydescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_InXItemCtryDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibInxitemctrydescRecRef _RibInxitemctrydescRecRefFactory = new RibInxitemctrydescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitemctrydescRecRefFactory; }
  /* constructor */
  public RibInxitemctrydescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitemctrydescRecRef r = new RibInxitemctrydescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibInxitemctrydescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibInxitemctrydescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibInxitemctrydescRecRef: "+exn.toString()); }
  }

  public RibInxitemctrydescRec getValue() throws SQLException
  {
     return (RibInxitemctrydescRec) RibInxitemctrydescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibInxitemctrydescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
