package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxitemdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXItemDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxitemdescTbl _RibInxitemdescTblFactory = new RibInxitemdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitemdescTblFactory; }
  /* constructors */
  public RibInxitemdescTbl()
  {
    this((RibInxitemdescRec[])null);
  }

  public RibInxitemdescTbl(RibInxitemdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxitemdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitemdescTbl a = new RibInxitemdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxitemdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxitemdescRec[] getArray() throws SQLException
  {
    return (RibInxitemdescRec[]) _array.getObjectArray(
      new RibInxitemdescRec[_array.length()]);
  }

  public RibInxitemdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxitemdescRec[]) _array.getObjectArray(index,
      new RibInxitemdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxitemdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxitemdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxitemdescRec getElement(long index) throws SQLException
  {
    return (RibInxitemdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxitemdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
