package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibInxitemimageRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_InXItemImage_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibInxitemimageRecRef _RibInxitemimageRecRefFactory = new RibInxitemimageRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitemimageRecRefFactory; }
  /* constructor */
  public RibInxitemimageRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitemimageRecRef r = new RibInxitemimageRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibInxitemimageRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibInxitemimageRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibInxitemimageRecRef: "+exn.toString()); }
  }

  public RibInxitemimageRec getValue() throws SQLException
  {
     return (RibInxitemimageRec) RibInxitemimageRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibInxitemimageRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
