package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxitemudadtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXItemUDADtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxitemudadtlTbl _RibInxitemudadtlTblFactory = new RibInxitemudadtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitemudadtlTblFactory; }
  /* constructors */
  public RibInxitemudadtlTbl()
  {
    this((RibInxitemudadtlRec[])null);
  }

  public RibInxitemudadtlTbl(RibInxitemudadtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxitemudadtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitemudadtlTbl a = new RibInxitemudadtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxitemudadtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxitemudadtlRec[] getArray() throws SQLException
  {
    return (RibInxitemudadtlRec[]) _array.getObjectArray(
      new RibInxitemudadtlRec[_array.length()]);
  }

  public RibInxitemudadtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxitemudadtlRec[]) _array.getObjectArray(index,
      new RibInxitemudadtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxitemudadtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxitemudadtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxitemudadtlRec getElement(long index) throws SQLException
  {
    return (RibInxitemudadtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxitemudadtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
