package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxizpdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXIZPDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxizpdescTbl _RibInxizpdescTblFactory = new RibInxizpdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxizpdescTblFactory; }
  /* constructors */
  public RibInxizpdescTbl()
  {
    this((RibInxizpdescRec[])null);
  }

  public RibInxizpdescTbl(RibInxizpdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxizpdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxizpdescTbl a = new RibInxizpdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxizpdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxizpdescRec[] getArray() throws SQLException
  {
    return (RibInxizpdescRec[]) _array.getObjectArray(
      new RibInxizpdescRec[_array.length()]);
  }

  public RibInxizpdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxizpdescRec[]) _array.getObjectArray(index,
      new RibInxizpdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxizpdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxizpdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxizpdescRec getElement(long index) throws SQLException
  {
    return (RibInxizpdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxizpdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
