package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibInxtsfdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_InXTsfDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibInxtsfdescRecRef _RibInxtsfdescRecRefFactory = new RibInxtsfdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibInxtsfdescRecRefFactory; }
  /* constructor */
  public RibInxtsfdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxtsfdescRecRef r = new RibInxtsfdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibInxtsfdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibInxtsfdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibInxtsfdescRecRef: "+exn.toString()); }
  }

  public RibInxtsfdescRec getValue() throws SQLException
  {
     return (RibInxtsfdescRec) RibInxtsfdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibInxtsfdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
