package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxtsfdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXTsfDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxtsfdescTbl _RibInxtsfdescTblFactory = new RibInxtsfdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxtsfdescTblFactory; }
  /* constructors */
  public RibInxtsfdescTbl()
  {
    this((RibInxtsfdescRec[])null);
  }

  public RibInxtsfdescTbl(RibInxtsfdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxtsfdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxtsfdescTbl a = new RibInxtsfdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxtsfdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxtsfdescRec[] getArray() throws SQLException
  {
    return (RibInxtsfdescRec[]) _array.getObjectArray(
      new RibInxtsfdescRec[_array.length()]);
  }

  public RibInxtsfdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxtsfdescRec[]) _array.getObjectArray(index,
      new RibInxtsfdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxtsfdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxtsfdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxtsfdescRec getElement(long index) throws SQLException
  {
    return (RibInxtsfdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxtsfdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
