package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxtsfdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXTsfDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxtsfdtlTbl _RibInxtsfdtlTblFactory = new RibInxtsfdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxtsfdtlTblFactory; }
  /* constructors */
  public RibInxtsfdtlTbl()
  {
    this((RibInxtsfdtlRec[])null);
  }

  public RibInxtsfdtlTbl(RibInxtsfdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxtsfdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxtsfdtlTbl a = new RibInxtsfdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxtsfdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxtsfdtlRec[] getArray() throws SQLException
  {
    return (RibInxtsfdtlRec[]) _array.getObjectArray(
      new RibInxtsfdtlRec[_array.length()]);
  }

  public RibInxtsfdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxtsfdtlRec[]) _array.getObjectArray(index,
      new RibInxtsfdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxtsfdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxtsfdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxtsfdtlRec getElement(long index) throws SQLException
  {
    return (RibInxtsfdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxtsfdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
