package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxiscdimdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXISCDimDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxiscdimdescTbl _RibLocofxiscdimdescTblFactory = new RibLocofxiscdimdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxiscdimdescTblFactory; }
  /* constructors */
  public RibLocofxiscdimdescTbl()
  {
    this((RibLocofxiscdimdescRec[])null);
  }

  public RibLocofxiscdimdescTbl(RibLocofxiscdimdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxiscdimdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxiscdimdescTbl a = new RibLocofxiscdimdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxiscdimdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxiscdimdescRec[] getArray() throws SQLException
  {
    return (RibLocofxiscdimdescRec[]) _array.getObjectArray(
      new RibLocofxiscdimdescRec[_array.length()]);
  }

  public RibLocofxiscdimdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxiscdimdescRec[]) _array.getObjectArray(index,
      new RibLocofxiscdimdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxiscdimdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxiscdimdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxiscdimdescRec getElement(long index) throws SQLException
  {
    return (RibLocofxiscdimdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxiscdimdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
