package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxitemsupctydescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXItemSupCtyDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxitemsupctydescTbl _RibLocofxitemsupctydescTblFactory = new RibLocofxitemsupctydescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxitemsupctydescTblFactory; }
  /* constructors */
  public RibLocofxitemsupctydescTbl()
  {
    this((RibLocofxitemsupctydescRec[])null);
  }

  public RibLocofxitemsupctydescTbl(RibLocofxitemsupctydescRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxitemsupctydescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxitemsupctydescTbl a = new RibLocofxitemsupctydescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxitemsupctydescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxitemsupctydescRec[] getArray() throws SQLException
  {
    return (RibLocofxitemsupctydescRec[]) _array.getObjectArray(
      new RibLocofxitemsupctydescRec[_array.length()]);
  }

  public RibLocofxitemsupctydescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxitemsupctydescRec[]) _array.getObjectArray(index,
      new RibLocofxitemsupctydescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxitemsupctydescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxitemsupctydescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxitemsupctydescRec getElement(long index) throws SQLException
  {
    return (RibLocofxitemsupctydescRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxitemsupctydescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
