package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibLocofxitemsupdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_LocOfXItemSupDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibLocofxitemsupdescRecRef _RibLocofxitemsupdescRecRefFactory = new RibLocofxitemsupdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxitemsupdescRecRefFactory; }
  /* constructor */
  public RibLocofxitemsupdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxitemsupdescRecRef r = new RibLocofxitemsupdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibLocofxitemsupdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibLocofxitemsupdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibLocofxitemsupdescRecRef: "+exn.toString()); }
  }

  public RibLocofxitemsupdescRec getValue() throws SQLException
  {
     return (RibLocofxitemsupdescRec) RibLocofxitemsupdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibLocofxitemsupdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
