package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxitemvatdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXItemVATDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxitemvatdescTbl _RibLocofxitemvatdescTblFactory = new RibLocofxitemvatdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxitemvatdescTblFactory; }
  /* constructors */
  public RibLocofxitemvatdescTbl()
  {
    this((RibLocofxitemvatdescRec[])null);
  }

  public RibLocofxitemvatdescTbl(RibLocofxitemvatdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxitemvatdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxitemvatdescTbl a = new RibLocofxitemvatdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxitemvatdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxitemvatdescRec[] getArray() throws SQLException
  {
    return (RibLocofxitemvatdescRec[]) _array.getObjectArray(
      new RibLocofxitemvatdescRec[_array.length()]);
  }

  public RibLocofxitemvatdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxitemvatdescRec[]) _array.getObjectArray(index,
      new RibLocofxitemvatdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxitemvatdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxitemvatdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxitemvatdescRec getElement(long index) throws SQLException
  {
    return (RibLocofxitemvatdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxitemvatdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
