package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxizpdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXIZPDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxizpdescTbl _RibLocofxizpdescTblFactory = new RibLocofxizpdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxizpdescTblFactory; }
  /* constructors */
  public RibLocofxizpdescTbl()
  {
    this((RibLocofxizpdescRec[])null);
  }

  public RibLocofxizpdescTbl(RibLocofxizpdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxizpdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxizpdescTbl a = new RibLocofxizpdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxizpdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxizpdescRec[] getArray() throws SQLException
  {
    return (RibLocofxizpdescRec[]) _array.getObjectArray(
      new RibLocofxizpdescRec[_array.length()]);
  }

  public RibLocofxizpdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxizpdescRec[]) _array.getObjectArray(index,
      new RibLocofxizpdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxizpdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxizpdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxizpdescRec getElement(long index) throws SQLException
  {
    return (RibLocofxizpdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxizpdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
