package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxtsfdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXTsfDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxtsfdtlTbl _RibLocofxtsfdtlTblFactory = new RibLocofxtsfdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxtsfdtlTblFactory; }
  /* constructors */
  public RibLocofxtsfdtlTbl()
  {
    this((RibLocofxtsfdtlRec[])null);
  }

  public RibLocofxtsfdtlTbl(RibLocofxtsfdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxtsfdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxtsfdtlTbl a = new RibLocofxtsfdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxtsfdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxtsfdtlRec[] getArray() throws SQLException
  {
    return (RibLocofxtsfdtlRec[]) _array.getObjectArray(
      new RibLocofxtsfdtlRec[_array.length()]);
  }

  public RibLocofxtsfdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxtsfdtlRec[]) _array.getObjectArray(index,
      new RibLocofxtsfdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxtsfdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxtsfdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxtsfdtlRec getElement(long index) throws SQLException
  {
    return (RibLocofxtsfdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxtsfdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
