/*@lineinfo:filename=RibXitembomdescRec*//*@lineinfo:user-code*//*@lineinfo:1^1*/package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.STRUCT;
import oracle.jpub.runtime.MutableStruct;
import sqlj.runtime.ref.DefaultContext;
import sqlj.runtime.ConnectionContext;

public class RibXitembomdescRec extends RibObject implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_XItemBOMDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.STRUCT;

  protected static int[] _sqlType =  { 2,12,12,12,12,12,12,2,2003,2003 };
  protected static ORADataFactory[] _factory = new ORADataFactory[10];
  static
  {
    _factory[8] = RibExtofxitembomdescTbl.getORADataFactory();
    _factory[9] = RibLocofxitembomdescTbl.getORADataFactory();
  }
  protected static final RibXitembomdescRec _RibXitembomdescRecFactory = new RibXitembomdescRec();

  public static ORADataFactory getORADataFactory()
  { return _RibXitembomdescRecFactory; }
  static
  { _map.put("RMS01.RIB_XItemBOMDesc_REC", _RibXitembomdescRecFactory); }

  /* constructors */
  protected void _init_struct(boolean init)
  { if (init) _struct = new MutableStruct(new Object[10], _sqlType, _factory); }
  public RibXitembomdescRec()
  { _init_struct(true); __tx = DefaultContext.getDefaultContext(); }
  public RibXitembomdescRec(DefaultContext c) /*throws SQLException*/
  { _init_struct(true); __tx = c; }
  public RibXitembomdescRec(Connection c) /*throws SQLException*/
  { _init_struct(true); __onn = c; }
  public RibXitembomdescRec(java.math.BigDecimal ribOid, String nsVersionV1, String nsNameXitemdesc, String nsTypeBo, String nsLocationBase, String nsLevelNontop, String componentItem, java.math.BigDecimal packQty, RibExtofxitembomdescTbl extofxitembomdescTbl, RibLocofxitembomdescTbl locofxitembomdescTbl) throws SQLException
  {
    _init_struct(true);
    setRibOid(ribOid);
    setNsVersionV1(nsVersionV1);
    setNsNameXitemdesc(nsNameXitemdesc);
    setNsTypeBo(nsTypeBo);
    setNsLocationBase(nsLocationBase);
    setNsLevelNontop(nsLevelNontop);
    setComponentItem(componentItem);
    setPackQty(packQty);
    setExtofxitembomdescTbl(extofxitembomdescTbl);
    setLocofxitembomdescTbl(locofxitembomdescTbl);
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__tx!=null && __onn!=c) release();
    __onn = c;
    return _struct.toDatum(c, _SQL_NAME);
  }


  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  { return create(null, d, sqlType); }
  public void setFrom(RibXitembomdescRec o) throws SQLException
  { setContextFrom(o); setValueFrom(o); }
  protected void setContextFrom(RibXitembomdescRec o) throws SQLException
  { release(); __tx = o.__tx; __onn = o.__onn; }
  protected void setValueFrom(RibXitembomdescRec o) { _struct = o._struct; }
  protected ORAData create(RibXitembomdescRec o, Datum d, int sqlType) throws SQLException
  {
    if (d == null) { if (o!=null) { o.release(); }; return null; }
    if (o == null) o = new RibXitembomdescRec();
    o._struct = new MutableStruct((STRUCT) d, _sqlType, _factory);
    o.__onn = ((STRUCT) d).getJavaSqlConnection();
    return o;
  }
  protected ORAData createExact(Datum d, int sqlType) throws SQLException
  { return create(null, d, sqlType); }

  /* accessor methods */
  public String getNsVersionV1() throws SQLException
  { return (String) _struct.getAttribute(1); }

  public void setNsVersionV1(String nsVersionV1) throws SQLException
  { _struct.setAttribute(1, nsVersionV1); }


  public String getNsNameXitemdesc() throws SQLException
  { return (String) _struct.getAttribute(2); }

  public void setNsNameXitemdesc(String nsNameXitemdesc) throws SQLException
  { _struct.setAttribute(2, nsNameXitemdesc); }


  public String getNsTypeBo() throws SQLException
  { return (String) _struct.getAttribute(3); }

  public void setNsTypeBo(String nsTypeBo) throws SQLException
  { _struct.setAttribute(3, nsTypeBo); }


  public String getNsLocationBase() throws SQLException
  { return (String) _struct.getAttribute(4); }

  public void setNsLocationBase(String nsLocationBase) throws SQLException
  { _struct.setAttribute(4, nsLocationBase); }


  public String getNsLevelNontop() throws SQLException
  { return (String) _struct.getAttribute(5); }

  public void setNsLevelNontop(String nsLevelNontop) throws SQLException
  { _struct.setAttribute(5, nsLevelNontop); }


  public String getComponentItem() throws SQLException
  { return (String) _struct.getAttribute(6); }

  public void setComponentItem(String componentItem) throws SQLException
  { _struct.setAttribute(6, componentItem); }


  public java.math.BigDecimal getPackQty() throws SQLException
  { return (java.math.BigDecimal) _struct.getAttribute(7); }

  public void setPackQty(java.math.BigDecimal packQty) throws SQLException
  { _struct.setAttribute(7, packQty); }


  public RibExtofxitembomdescTbl getExtofxitembomdescTbl() throws SQLException
  { return (RibExtofxitembomdescTbl) _struct.getAttribute(8); }

  public void setExtofxitembomdescTbl(RibExtofxitembomdescTbl extofxitembomdescTbl) throws SQLException
  { _struct.setAttribute(8, extofxitembomdescTbl); }


  public RibLocofxitembomdescTbl getLocofxitembomdescTbl() throws SQLException
  { return (RibLocofxitembomdescTbl) _struct.getAttribute(9); }

  public void setLocofxitembomdescTbl(RibLocofxitembomdescTbl locofxitembomdescTbl) throws SQLException
  { _struct.setAttribute(9, locofxitembomdescTbl); }


  public RibXitembomdescRec appendnodevalues (
    String I_PREFIX)
  throws java.sql.SQLException
  {
 try {
    RibXitembomdescRec __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:155^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n       :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"0oracle.retail.microapps.item.ribtypes.RibXitembomdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_XItemBOMDesc_REC");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RMS01.RIB_XItemBOMDesc_REC"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibXitembomdescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibXitembomdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:160^5*/
    return __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    RibXitembomdescRec __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:168^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n       :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"1oracle.retail.microapps.item.ribtypes.RibXitembomdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_XItemBOMDesc_REC");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RMS01.RIB_XItemBOMDesc_REC"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibXitembomdescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibXitembomdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:173^5*/
    return __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
  }

  public RibObject appendnodevaluesRS (
    String I_PREFIX)
  throws java.sql.SQLException
  {
 try {
    RibObject __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:188^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        I_PREFIX => :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n      I_PREFIX =>  :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"2oracle.retail.microapps.item.ribtypes.RibXitembomdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_OBJECT");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RMS01.RIB_OBJECT"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibObject)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibObject.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:193^5*/
    return __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    RibObject __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:201^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        I_PREFIX => :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n      I_PREFIX =>  :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"3oracle.retail.microapps.item.ribtypes.RibXitembomdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_OBJECT");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RMS01.RIB_OBJECT"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibObject)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibObject.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:206^5*/
    return __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
  }

  public RibXitembomdescRec ribXitembomdescRec (
    java.math.BigDecimal RIB_OID,
    String COMPONENT_ITEM,
    java.math.BigDecimal PACK_QTY,
    RibExtofxitembomdescTbl EXTOFXITEMBOMDESC_TBL,
    RibXitembomdescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitembomdescRec __jPt_temp = (RibXitembomdescRec) this;
    RibXitembomdescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:226^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemBOMDesc_REC(
//        :RIB_OID,
//        :COMPONENT_ITEM,
//        :PACK_QTY,
//        :EXTOFXITEMBOMDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemBOMDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"4oracle.retail.microapps.item.ribtypes.RibXitembomdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_XItemBOMDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,COMPONENT_ITEM);
   __sJT_st.setBigDecimal(4,PACK_QTY);
   if (EXTOFXITEMBOMDESC_TBL==null) __sJT_st.setNull(5,2003,"RMS01.RIB_ExtOfXItemBOMDesc_TBL"); else __sJT_st.setORAData(5,EXTOFXITEMBOMDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitembomdescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibXitembomdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:234^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:241^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemBOMDesc_REC(
//        :RIB_OID,
//        :COMPONENT_ITEM,
//        :PACK_QTY,
//        :EXTOFXITEMBOMDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemBOMDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"5oracle.retail.microapps.item.ribtypes.RibXitembomdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_XItemBOMDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,COMPONENT_ITEM);
   __sJT_st.setBigDecimal(4,PACK_QTY);
   if (EXTOFXITEMBOMDESC_TBL==null) __sJT_st.setNull(5,2003,"RMS01.RIB_ExtOfXItemBOMDesc_TBL"); else __sJT_st.setORAData(5,EXTOFXITEMBOMDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitembomdescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibXitembomdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:249^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }

  public RibXitembomdescRec ribXitembomdescRec (
    java.math.BigDecimal RIB_OID,
    String COMPONENT_ITEM,
    java.math.BigDecimal PACK_QTY,
    RibExtofxitembomdescTbl EXTOFXITEMBOMDESC_TBL,
    RibLocofxitembomdescTbl LOCOFXITEMBOMDESC_TBL,
    RibXitembomdescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitembomdescRec __jPt_temp = (RibXitembomdescRec) this;
    RibXitembomdescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:271^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemBOMDesc_REC(
//        :RIB_OID,
//        :COMPONENT_ITEM,
//        :PACK_QTY,
//        :EXTOFXITEMBOMDESC_TBL,
//        :LOCOFXITEMBOMDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemBOMDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"6oracle.retail.microapps.item.ribtypes.RibXitembomdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_XItemBOMDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,COMPONENT_ITEM);
   __sJT_st.setBigDecimal(4,PACK_QTY);
   if (EXTOFXITEMBOMDESC_TBL==null) __sJT_st.setNull(5,2003,"RMS01.RIB_ExtOfXItemBOMDesc_TBL"); else __sJT_st.setORAData(5,EXTOFXITEMBOMDESC_TBL);
   if (LOCOFXITEMBOMDESC_TBL==null) __sJT_st.setNull(6,2003,"RMS01.RIB_LocOfXItemBOMDesc_TBL"); else __sJT_st.setORAData(6,LOCOFXITEMBOMDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitembomdescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibXitembomdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:280^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:287^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemBOMDesc_REC(
//        :RIB_OID,
//        :COMPONENT_ITEM,
//        :PACK_QTY,
//        :EXTOFXITEMBOMDESC_TBL,
//        :LOCOFXITEMBOMDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemBOMDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"7oracle.retail.microapps.item.ribtypes.RibXitembomdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_XItemBOMDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,COMPONENT_ITEM);
   __sJT_st.setBigDecimal(4,PACK_QTY);
   if (EXTOFXITEMBOMDESC_TBL==null) __sJT_st.setNull(5,2003,"RMS01.RIB_ExtOfXItemBOMDesc_TBL"); else __sJT_st.setORAData(5,EXTOFXITEMBOMDESC_TBL);
   if (LOCOFXITEMBOMDESC_TBL==null) __sJT_st.setNull(6,2003,"RMS01.RIB_LocOfXItemBOMDesc_TBL"); else __sJT_st.setORAData(6,LOCOFXITEMBOMDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitembomdescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibXitembomdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:296^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }

  public RibXitembomdescRec ribXitembomdescRec (
    java.math.BigDecimal RIB_OID,
    String COMPONENT_ITEM,
    java.math.BigDecimal PACK_QTY,
    RibXitembomdescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitembomdescRec __jPt_temp = (RibXitembomdescRec) this;
    RibXitembomdescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:316^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemBOMDesc_REC(
//        :RIB_OID,
//        :COMPONENT_ITEM,
//        :PACK_QTY);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemBOMDesc_REC(\n       :2 ,\n       :3 ,\n       :4 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"8oracle.retail.microapps.item.ribtypes.RibXitembomdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_XItemBOMDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,COMPONENT_ITEM);
   __sJT_st.setBigDecimal(4,PACK_QTY);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitembomdescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibXitembomdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:323^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:330^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemBOMDesc_REC(
//        :RIB_OID,
//        :COMPONENT_ITEM,
//        :PACK_QTY);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemBOMDesc_REC(\n       :2 ,\n       :3 ,\n       :4 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"9oracle.retail.microapps.item.ribtypes.RibXitembomdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_XItemBOMDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,COMPONENT_ITEM);
   __sJT_st.setBigDecimal(4,PACK_QTY);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitembomdescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibXitembomdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:337^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }
}/*@lineinfo:generated-code*/