package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXitemsupdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_XItemSupDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXitemsupdescTbl _RibXitemsupdescTblFactory = new RibXitemsupdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemsupdescTblFactory; }
  /* constructors */
  public RibXitemsupdescTbl()
  {
    this((RibXitemsupdescRec[])null);
  }

  public RibXitemsupdescTbl(RibXitemsupdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibXitemsupdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibXitemsupdescTbl a = new RibXitemsupdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXitemsupdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXitemsupdescRec[] getArray() throws SQLException
  {
    return (RibXitemsupdescRec[]) _array.getObjectArray(
      new RibXitemsupdescRec[_array.length()]);
  }

  public RibXitemsupdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXitemsupdescRec[]) _array.getObjectArray(index,
      new RibXitemsupdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXitemsupdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXitemsupdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXitemsupdescRec getElement(long index) throws SQLException
  {
    return (RibXitemsupdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibXitemsupdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
