package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXizpdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_XIZPDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXizpdescTbl _RibXizpdescTblFactory = new RibXizpdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXizpdescTblFactory; }
  /* constructors */
  public RibXizpdescTbl()
  {
    this((RibXizpdescRec[])null);
  }

  public RibXizpdescTbl(RibXizpdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibXizpdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibXizpdescTbl a = new RibXizpdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXizpdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXizpdescRec[] getArray() throws SQLException
  {
    return (RibXizpdescRec[]) _array.getObjectArray(
      new RibXizpdescRec[_array.length()]);
  }

  public RibXizpdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXizpdescRec[]) _array.getObjectArray(index,
      new RibXizpdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXizpdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXizpdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXizpdescRec getElement(long index) throws SQLException
  {
    return (RibXizpdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibXizpdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
