package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXtsfdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_XTsfDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXtsfdtlTbl _RibXtsfdtlTblFactory = new RibXtsfdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXtsfdtlTblFactory; }
  /* constructors */
  public RibXtsfdtlTbl()
  {
    this((RibXtsfdtlRec[])null);
  }

  public RibXtsfdtlTbl(RibXtsfdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibXtsfdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibXtsfdtlTbl a = new RibXtsfdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXtsfdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXtsfdtlRec[] getArray() throws SQLException
  {
    return (RibXtsfdtlRec[]) _array.getObjectArray(
      new RibXtsfdtlRec[_array.length()]);
  }

  public RibXtsfdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXtsfdtlRec[]) _array.getObjectArray(index,
      new RibXtsfdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXtsfdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXtsfdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXtsfdtlRec getElement(long index) throws SQLException
  {
    return (RibXtsfdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibXtsfdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
