package oracle.retail.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibBrxorderdtlRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_BrXOrderDtl_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibBrxorderdtlRecRef _RibBrxorderdtlRecRefFactory = new RibBrxorderdtlRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxorderdtlRecRefFactory; }
  /* constructor */
  public RibBrxorderdtlRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxorderdtlRecRef r = new RibBrxorderdtlRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibBrxorderdtlRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibBrxorderdtlRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibBrxorderdtlRecRef: "+exn.toString()); }
  }

  public RibBrxorderdtlRec getValue() throws SQLException
  {
     return (RibBrxorderdtlRec) RibBrxorderdtlRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibBrxorderdtlRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
