package oracle.retail.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibEofbrxorderdtlRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_EOfBrXOrderDtl_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibEofbrxorderdtlRecRef _RibEofbrxorderdtlRecRefFactory = new RibEofbrxorderdtlRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxorderdtlRecRefFactory; }
  /* constructor */
  public RibEofbrxorderdtlRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxorderdtlRecRef r = new RibEofbrxorderdtlRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibEofbrxorderdtlRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibEofbrxorderdtlRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibEofbrxorderdtlRecRef: "+exn.toString()); }
  }

  public RibEofbrxorderdtlRec getValue() throws SQLException
  {
     return (RibEofbrxorderdtlRec) RibEofbrxorderdtlRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibEofbrxorderdtlRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
