package oracle.retail.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxorderdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXOrderDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxorderdtlTbl _RibEofinxorderdtlTblFactory = new RibEofinxorderdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxorderdtlTblFactory; }
  /* constructors */
  public RibEofinxorderdtlTbl()
  {
    this((RibEofinxorderdtlRec[])null);
  }

  public RibEofinxorderdtlTbl(RibEofinxorderdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxorderdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxorderdtlTbl a = new RibEofinxorderdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxorderdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxorderdtlRec[] getArray() throws SQLException
  {
    return (RibEofinxorderdtlRec[]) _array.getObjectArray(
      new RibEofinxorderdtlRec[_array.length()]);
  }

  public RibEofinxorderdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxorderdtlRec[]) _array.getObjectArray(index,
      new RibEofinxorderdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxorderdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxorderdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxorderdtlRec getElement(long index) throws SQLException
  {
    return (RibEofinxorderdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxorderdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
