package oracle.retail.microapps.order.create.am.view.VSupMsobNVO1VO;

import oracle.jbo.Row;
import oracle.jbo.ViewObject;

import oracle.retail.microapps.order.create.am.applicationModule.CreateOrderAMFixture;

import org.junit.*;
import static org.junit.Assert.*;

public class VSupMsobNVO1VOTest {
    private CreateOrderAMFixture fixture1 = CreateOrderAMFixture.getInstance();

    public VSupMsobNVO1VOTest() {
    }

    @Test
    public void testAccess() {
        ViewObject view = fixture1.getApplicationModule().findViewObject("VSupMsobNVO1");
        assertNotNull(view);
    }
  @Test
  public void testVOQuery() {
    ViewObject SupplierVO = fixture1.getApplicationModule().findViewObject("VSupMsobNVO1");
    //get a valid supplier id.
    SupplierVO.executeQuery();
    Row[] rows = SupplierVO.getAllRowsInRange();
    Assert.assertTrue(rows.length > 0);
  }
  
  @Test
  public void testVOMandatoryAttribute_supplierId() {
    ViewObject SupplierVO = fixture1.getApplicationModule().findViewObject("VSupMsobNVO1");
    SupplierVO.executeQuery();
    Row[] rows = SupplierVO.getAllRowsInRange();
    //there should be rows present for this vo in RMS test schema.
    //if this assumption is wrong, test will abort.
    Assume.assumeTrue(rows.length > 0);
    Object voAttr = rows[0].getAttribute("Supplier");
    Assert.assertTrue(voAttr != null);
  }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }
}
