package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibExtofxitemsupdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RIB_ExtOfXItemSupDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibExtofxitemsupdescRecRef _RibExtofxitemsupdescRecRefFactory = new RibExtofxitemsupdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemsupdescRecRefFactory; }
  /* constructor */
  public RibExtofxitemsupdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibExtofxitemsupdescRecRef r = new RibExtofxitemsupdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibExtofxitemsupdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibExtofxitemsupdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibExtofxitemsupdescRecRef: "+exn.toString()); }
  }

  public RibExtofxitemsupdescRec getValue() throws SQLException
  {
     return (RibExtofxitemsupdescRec)RibExtofxitemsupdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibExtofxitemsupdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
