package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxitemsupdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_ExtOfXItemSupDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxitemsupdescTbl _RibExtofxitemsupdescTblFactory = new RibExtofxitemsupdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemsupdescTblFactory; }
  /* constructors */
  public RibExtofxitemsupdescTbl()
  {
    this((RibExtofxitemsupdescRec[])null);
  }

  public RibExtofxitemsupdescTbl(RibExtofxitemsupdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxitemsupdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__schemaName!=null) return _array.toDatum(c,__schemaName + "." + _SQL_NAME);
    return _array.toDatum(c, _SQL_NAME);
  }
  private String __schemaName = null;
  public void __setSchemaName(String schemaName) { __schemaName = schemaName; }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibExtofxitemsupdescTbl a = new RibExtofxitemsupdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxitemsupdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxitemsupdescRec[] getArray() throws SQLException
  {
    return (RibExtofxitemsupdescRec[]) _array.getObjectArray(
      new RibExtofxitemsupdescRec[_array.length()]);
  }

  public RibExtofxitemsupdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxitemsupdescRec[]) _array.getObjectArray(index,
      new RibExtofxitemsupdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxitemsupdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxitemsupdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxitemsupdescRec getElement(long index) throws SQLException
  {
    return (RibExtofxitemsupdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxitemsupdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
