package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibXitemsupdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RIB_XItemSupDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibXitemsupdescRecRef _RibXitemsupdescRecRefFactory = new RibXitemsupdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemsupdescRecRefFactory; }
  /* constructor */
  public RibXitemsupdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibXitemsupdescRecRef r = new RibXitemsupdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibXitemsupdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibXitemsupdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibXitemsupdescRecRef: "+exn.toString()); }
  }

  public RibXitemsupdescRec getValue() throws SQLException
  {
     return (RibXitemsupdescRec)RibXitemsupdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibXitemsupdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
