package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibXitemvatdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RIB_XItemVATDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibXitemvatdescRecRef _RibXitemvatdescRecRefFactory = new RibXitemvatdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemvatdescRecRefFactory; }
  /* constructor */
  public RibXitemvatdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibXitemvatdescRecRef r = new RibXitemvatdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibXitemvatdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibXitemvatdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibXitemvatdescRecRef: "+exn.toString()); }
  }

  public RibXitemvatdescRec getValue() throws SQLException
  {
     return (RibXitemvatdescRec)RibXitemvatdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibXitemvatdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
