package oracle.retail.microapps.item.transfer.am;

import oracle.retail.microapps.item.transfer.am.applicationModule.TransferItemAMFixture;
import oracle.retail.microapps.item.transfer.am.applicationModule.TransferItemAMTest;
import oracle.retail.microapps.item.transfer.am.view.DepartmentVO1VO.DepartmentVO1VOTest;
import oracle.retail.microapps.item.transfer.am.view.DestLocationVO1VO.DestLocationVO1VOTest;
import oracle.retail.microapps.item.transfer.am.view.ItemVO1VO.ItemVO1VOTest;
import oracle.retail.microapps.item.transfer.am.view.SrcLocationVO1VO.SrcLocationVO1VOTest;
import oracle.retail.microapps.item.transfer.am.view.SystemOptionsVO1VO.SystemOptionsVO1VOTest;

import org.junit.*;
import org.junit.runner.RunWith;
import org.junit.runners.Suite;

@RunWith(Suite.class)
@Suite.SuiteClasses( { SystemOptionsVO1VOTest.class,
                       SrcLocationVO1VOTest.class, ItemVO1VOTest.class,
                       DestLocationVO1VOTest.class, DepartmentVO1VOTest.class, 
                       TransferItemAMTest.class })
public class AllTransferItemTests {
    @BeforeClass
    public static void setUp() {
    }

    @AfterClass
    public static void tearDown() throws Exception {
        TransferItemAMFixture.getInstance().release();
    }
}
