package oracle.training.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxorderdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXOrderDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxorderdescTbl _RibBrxorderdescTblFactory = new RibBrxorderdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxorderdescTblFactory; }
  /* constructors */
  public RibBrxorderdescTbl()
  {
    this((RibBrxorderdescRec[])null);
  }

  public RibBrxorderdescTbl(RibBrxorderdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxorderdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxorderdescTbl a = new RibBrxorderdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxorderdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxorderdescRec[] getArray() throws SQLException
  {
    return (RibBrxorderdescRec[]) _array.getObjectArray(
      new RibBrxorderdescRec[_array.length()]);
  }

  public RibBrxorderdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxorderdescRec[]) _array.getObjectArray(index,
      new RibBrxorderdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxorderdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxorderdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxorderdescRec getElement(long index) throws SQLException
  {
    return (RibBrxorderdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxorderdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
