package oracle.training.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibEofbrxorderdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_EOfBrXOrderDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibEofbrxorderdescRecRef _RibEofbrxorderdescRecRefFactory = new RibEofbrxorderdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxorderdescRecRefFactory; }
  /* constructor */
  public RibEofbrxorderdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxorderdescRecRef r = new RibEofbrxorderdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibEofbrxorderdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibEofbrxorderdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibEofbrxorderdescRecRef: "+exn.toString()); }
  }

  public RibEofbrxorderdescRec getValue() throws SQLException
  {
     return (RibEofbrxorderdescRec) RibEofbrxorderdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibEofbrxorderdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
