package oracle.training.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxorderdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXOrderDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxorderdescTbl _RibInxorderdescTblFactory = new RibInxorderdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxorderdescTblFactory; }
  /* constructors */
  public RibInxorderdescTbl()
  {
    this((RibInxorderdescRec[])null);
  }

  public RibInxorderdescTbl(RibInxorderdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxorderdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxorderdescTbl a = new RibInxorderdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxorderdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxorderdescRec[] getArray() throws SQLException
  {
    return (RibInxorderdescRec[]) _array.getObjectArray(
      new RibInxorderdescRec[_array.length()]);
  }

  public RibInxorderdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxorderdescRec[]) _array.getObjectArray(index,
      new RibInxorderdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxorderdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxorderdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxorderdescRec getElement(long index) throws SQLException
  {
    return (RibInxorderdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxorderdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
