package oracle.training.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibLocofxorderdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_LocOfXOrderDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibLocofxorderdescRecRef _RibLocofxorderdescRecRefFactory = new RibLocofxorderdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxorderdescRecRefFactory; }
  /* constructor */
  public RibLocofxorderdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxorderdescRecRef r = new RibLocofxorderdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibLocofxorderdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibLocofxorderdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibLocofxorderdescRecRef: "+exn.toString()); }
  }

  public RibLocofxorderdescRec getValue() throws SQLException
  {
     return (RibLocofxorderdescRec) RibLocofxorderdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibLocofxorderdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
