package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibExtofxitembomdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RIB_ExtOfXItemBOMDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibExtofxitembomdescRecRef _RibExtofxitembomdescRecRefFactory = new RibExtofxitembomdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitembomdescRecRefFactory; }
  /* constructor */
  public RibExtofxitembomdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibExtofxitembomdescRecRef r = new RibExtofxitembomdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibExtofxitembomdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibExtofxitembomdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibExtofxitembomdescRecRef: "+exn.toString()); }
  }

  public RibExtofxitembomdescRec getValue() throws SQLException
  {
     return (RibExtofxitembomdescRec)RibExtofxitembomdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibExtofxitembomdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
