package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibExtofxitemimageRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RIB_ExtOfXItemImage_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibExtofxitemimageRecRef _RibExtofxitemimageRecRefFactory = new RibExtofxitemimageRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemimageRecRefFactory; }
  /* constructor */
  public RibExtofxitemimageRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibExtofxitemimageRecRef r = new RibExtofxitemimageRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibExtofxitemimageRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibExtofxitemimageRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibExtofxitemimageRecRef: "+exn.toString()); }
  }

  public RibExtofxitemimageRec getValue() throws SQLException
  {
     return (RibExtofxitemimageRec)RibExtofxitemimageRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibExtofxitemimageRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
