package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxitemimageTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_ExtOfXItemImage_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxitemimageTbl _RibExtofxitemimageTblFactory = new RibExtofxitemimageTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemimageTblFactory; }
  /* constructors */
  public RibExtofxitemimageTbl()
  {
    this((RibExtofxitemimageRec[])null);
  }

  public RibExtofxitemimageTbl(RibExtofxitemimageRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxitemimageRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__schemaName!=null) return _array.toDatum(c,__schemaName + "." + _SQL_NAME);
    return _array.toDatum(c, _SQL_NAME);
  }
  private String __schemaName = null;
  public void __setSchemaName(String schemaName) { __schemaName = schemaName; }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibExtofxitemimageTbl a = new RibExtofxitemimageTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxitemimageRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxitemimageRec[] getArray() throws SQLException
  {
    return (RibExtofxitemimageRec[]) _array.getObjectArray(
      new RibExtofxitemimageRec[_array.length()]);
  }

  public RibExtofxitemimageRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxitemimageRec[]) _array.getObjectArray(index,
      new RibExtofxitemimageRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxitemimageRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxitemimageRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxitemimageRec getElement(long index) throws SQLException
  {
    return (RibExtofxitemimageRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxitemimageRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
