package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxitemseasonTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_ExtOfXItemSeason_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxitemseasonTbl _RibExtofxitemseasonTblFactory = new RibExtofxitemseasonTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemseasonTblFactory; }
  /* constructors */
  public RibExtofxitemseasonTbl()
  {
    this((RibExtofxitemseasonRec[])null);
  }

  public RibExtofxitemseasonTbl(RibExtofxitemseasonRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxitemseasonRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__schemaName!=null) return _array.toDatum(c,__schemaName + "." + _SQL_NAME);
    return _array.toDatum(c, _SQL_NAME);
  }
  private String __schemaName = null;
  public void __setSchemaName(String schemaName) { __schemaName = schemaName; }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibExtofxitemseasonTbl a = new RibExtofxitemseasonTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxitemseasonRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxitemseasonRec[] getArray() throws SQLException
  {
    return (RibExtofxitemseasonRec[]) _array.getObjectArray(
      new RibExtofxitemseasonRec[_array.length()]);
  }

  public RibExtofxitemseasonRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxitemseasonRec[]) _array.getObjectArray(index,
      new RibExtofxitemseasonRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxitemseasonRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxitemseasonRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxitemseasonRec getElement(long index) throws SQLException
  {
    return (RibExtofxitemseasonRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxitemseasonRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
