package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibExtofxitemsupctydescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RIB_ExtOfXItemSupCtyDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibExtofxitemsupctydescRecRef _RibExtofxitemsupctydescRecRefFactory = new RibExtofxitemsupctydescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemsupctydescRecRefFactory; }
  /* constructor */
  public RibExtofxitemsupctydescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibExtofxitemsupctydescRecRef r = new RibExtofxitemsupctydescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibExtofxitemsupctydescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibExtofxitemsupctydescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibExtofxitemsupctydescRecRef: "+exn.toString()); }
  }

  public RibExtofxitemsupctydescRec getValue() throws SQLException
  {
     return (RibExtofxitemsupctydescRec)RibExtofxitemsupctydescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibExtofxitemsupctydescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
