package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxitemvatdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_ExtOfXItemVATDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxitemvatdescTbl _RibExtofxitemvatdescTblFactory = new RibExtofxitemvatdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemvatdescTblFactory; }
  /* constructors */
  public RibExtofxitemvatdescTbl()
  {
    this((RibExtofxitemvatdescRec[])null);
  }

  public RibExtofxitemvatdescTbl(RibExtofxitemvatdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxitemvatdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__schemaName!=null) return _array.toDatum(c,__schemaName + "." + _SQL_NAME);
    return _array.toDatum(c, _SQL_NAME);
  }
  private String __schemaName = null;
  public void __setSchemaName(String schemaName) { __schemaName = schemaName; }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibExtofxitemvatdescTbl a = new RibExtofxitemvatdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxitemvatdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxitemvatdescRec[] getArray() throws SQLException
  {
    return (RibExtofxitemvatdescRec[]) _array.getObjectArray(
      new RibExtofxitemvatdescRec[_array.length()]);
  }

  public RibExtofxitemvatdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxitemvatdescRec[]) _array.getObjectArray(index,
      new RibExtofxitemvatdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxitemvatdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxitemvatdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxitemvatdescRec getElement(long index) throws SQLException
  {
    return (RibExtofxitemvatdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxitemvatdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
