package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibXitemdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RIB_XItemDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibXitemdescRecRef _RibXitemdescRecRefFactory = new RibXitemdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemdescRecRefFactory; }
  /* constructor */
  public RibXitemdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibXitemdescRecRef r = new RibXitemdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibXitemdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibXitemdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibXitemdescRecRef: "+exn.toString()); }
  }

  public RibXitemdescRec getValue() throws SQLException
  {
     return (RibXitemdescRec)RibXitemdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibXitemdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
