/*@lineinfo:filename=RibXitemsupctydescRec*//*@lineinfo:user-code*//*@lineinfo:1^1*/package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.STRUCT;
import oracle.jpub.runtime.MutableStruct;
import sqlj.runtime.ref.DefaultContext;
import sqlj.runtime.ConnectionContext;

public class RibXitemsupctydescRec extends RibObject implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_XItemSupCtyDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.STRUCT;

  protected static int[] _sqlType =  { 2,12,12,12,12,12,12,12,2,2003,2,2,2,2,12,12,12,12,2,2,2,2,2003,2003 };
  protected static ORADataFactory[] _factory = new ORADataFactory[24];
  static
  {
    _factory[9] = RibXisclocdescTbl.getORADataFactory();
    _factory[22] = RibXiscdimdescTbl.getORADataFactory();
    _factory[23] = RibExtofxitemsupctydescTbl.getORADataFactory();
  }
  protected static final RibXitemsupctydescRec _RibXitemsupctydescRecFactory = new RibXitemsupctydescRec();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemsupctydescRecFactory; }
  static
  { _map.put("RIB_XItemSupCtyDesc_REC", _RibXitemsupctydescRecFactory); }

  /* constructors */
  protected void _init_struct(boolean init)
  { if (init) _struct = new MutableStruct(new Object[24], _sqlType, _factory); }
  public RibXitemsupctydescRec()
  { _init_struct(true); __tx = DefaultContext.getDefaultContext(); }
  public RibXitemsupctydescRec(DefaultContext c) /*throws SQLException*/
  { _init_struct(true); __tx = c; }
  public RibXitemsupctydescRec(Connection c) /*throws SQLException*/
  { _init_struct(true); __onn = c; }
  public RibXitemsupctydescRec(java.math.BigDecimal ribOid, String nsVersionV1, String nsNameXitemdesc, String nsTypeBo, String nsLocationBase, String nsLevelNontop, String originCountryId, String primaryCountryInd, java.math.BigDecimal unitCost, RibXisclocdescTbl xisclocdescTbl, java.math.BigDecimal leadTime, java.math.BigDecimal pickupLeadTime, java.math.BigDecimal minOrderQty, java.math.BigDecimal maxOrderQty, String suppHierLvl1, String suppHierLvl2, String suppHierLvl3, String defaultUop, java.math.BigDecimal suppPackSize, java.math.BigDecimal innerPackSize, java.math.BigDecimal ti, java.math.BigDecimal hi, RibXiscdimdescTbl xiscdimdescTbl, RibExtofxitemsupctydescTbl extofxitemsupctydescTbl) throws SQLException
  {
    _init_struct(true);
    setRibOid(ribOid);
    setNsVersionV1(nsVersionV1);
    setNsNameXitemdesc(nsNameXitemdesc);
    setNsTypeBo(nsTypeBo);
    setNsLocationBase(nsLocationBase);
    setNsLevelNontop(nsLevelNontop);
    setOriginCountryId(originCountryId);
    setPrimaryCountryInd(primaryCountryInd);
    setUnitCost(unitCost);
    setXisclocdescTbl(xisclocdescTbl);
    setLeadTime(leadTime);
    setPickupLeadTime(pickupLeadTime);
    setMinOrderQty(minOrderQty);
    setMaxOrderQty(maxOrderQty);
    setSuppHierLvl1(suppHierLvl1);
    setSuppHierLvl2(suppHierLvl2);
    setSuppHierLvl3(suppHierLvl3);
    setDefaultUop(defaultUop);
    setSuppPackSize(suppPackSize);
    setInnerPackSize(innerPackSize);
    setTi(ti);
    setHi(hi);
    setXiscdimdescTbl(xiscdimdescTbl);
    setExtofxitemsupctydescTbl(extofxitemsupctydescTbl);
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__tx!=null && __onn!=c) release();
    __onn = c;
    return _struct.toDatum(c, _SQL_NAME);
  }


  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  { return create(null, d, sqlType); }
  public void setFrom(RibXitemsupctydescRec o) throws SQLException
  { setContextFrom(o); setValueFrom(o); }
  protected void setContextFrom(RibXitemsupctydescRec o) throws SQLException
  { release(); __tx = o.__tx; __onn = o.__onn; }
  protected void setValueFrom(RibXitemsupctydescRec o) { _struct = o._struct; }
  protected ORAData create(RibXitemsupctydescRec o, Datum d, int sqlType) throws SQLException
  {
    if (d == null) { if (o!=null) { o.release(); }; return null; }
    if (o == null) o = new RibXitemsupctydescRec();
    o._struct = new MutableStruct((STRUCT) d, _sqlType, _factory);
    o.__onn = ((STRUCT) d).getJavaSqlConnection();
    return o;
  }
  protected ORAData createExact(Datum d, int sqlType) throws SQLException
  { return create(null, d, sqlType); }

  /* accessor methods */
  public String getNsVersionV1() throws SQLException
  { return (String) _struct.getAttribute(1); }

  public void setNsVersionV1(String nsVersionV1) throws SQLException
  { _struct.setAttribute(1, nsVersionV1); }


  public String getNsNameXitemdesc() throws SQLException
  { return (String) _struct.getAttribute(2); }

  public void setNsNameXitemdesc(String nsNameXitemdesc) throws SQLException
  { _struct.setAttribute(2, nsNameXitemdesc); }


  public String getNsTypeBo() throws SQLException
  { return (String) _struct.getAttribute(3); }

  public void setNsTypeBo(String nsTypeBo) throws SQLException
  { _struct.setAttribute(3, nsTypeBo); }


  public String getNsLocationBase() throws SQLException
  { return (String) _struct.getAttribute(4); }

  public void setNsLocationBase(String nsLocationBase) throws SQLException
  { _struct.setAttribute(4, nsLocationBase); }


  public String getNsLevelNontop() throws SQLException
  { return (String) _struct.getAttribute(5); }

  public void setNsLevelNontop(String nsLevelNontop) throws SQLException
  { _struct.setAttribute(5, nsLevelNontop); }


  public String getOriginCountryId() throws SQLException
  { return (String) _struct.getAttribute(6); }

  public void setOriginCountryId(String originCountryId) throws SQLException
  { _struct.setAttribute(6, originCountryId); }


  public String getPrimaryCountryInd() throws SQLException
  { return (String) _struct.getAttribute(7); }

  public void setPrimaryCountryInd(String primaryCountryInd) throws SQLException
  { _struct.setAttribute(7, primaryCountryInd); }


  public java.math.BigDecimal getUnitCost() throws SQLException
  { return (java.math.BigDecimal) _struct.getAttribute(8); }

  public void setUnitCost(java.math.BigDecimal unitCost) throws SQLException
  { _struct.setAttribute(8, unitCost); }


  public RibXisclocdescTbl getXisclocdescTbl() throws SQLException
  { return (RibXisclocdescTbl) _struct.getAttribute(9); }

  public void setXisclocdescTbl(RibXisclocdescTbl xisclocdescTbl) throws SQLException
  { _struct.setAttribute(9, xisclocdescTbl); }


  public java.math.BigDecimal getLeadTime() throws SQLException
  { return (java.math.BigDecimal) _struct.getAttribute(10); }

  public void setLeadTime(java.math.BigDecimal leadTime) throws SQLException
  { _struct.setAttribute(10, leadTime); }


  public java.math.BigDecimal getPickupLeadTime() throws SQLException
  { return (java.math.BigDecimal) _struct.getAttribute(11); }

  public void setPickupLeadTime(java.math.BigDecimal pickupLeadTime) throws SQLException
  { _struct.setAttribute(11, pickupLeadTime); }


  public java.math.BigDecimal getMinOrderQty() throws SQLException
  { return (java.math.BigDecimal) _struct.getAttribute(12); }

  public void setMinOrderQty(java.math.BigDecimal minOrderQty) throws SQLException
  { _struct.setAttribute(12, minOrderQty); }


  public java.math.BigDecimal getMaxOrderQty() throws SQLException
  { return (java.math.BigDecimal) _struct.getAttribute(13); }

  public void setMaxOrderQty(java.math.BigDecimal maxOrderQty) throws SQLException
  { _struct.setAttribute(13, maxOrderQty); }


  public String getSuppHierLvl1() throws SQLException
  { return (String) _struct.getAttribute(14); }

  public void setSuppHierLvl1(String suppHierLvl1) throws SQLException
  { _struct.setAttribute(14, suppHierLvl1); }


  public String getSuppHierLvl2() throws SQLException
  { return (String) _struct.getAttribute(15); }

  public void setSuppHierLvl2(String suppHierLvl2) throws SQLException
  { _struct.setAttribute(15, suppHierLvl2); }


  public String getSuppHierLvl3() throws SQLException
  { return (String) _struct.getAttribute(16); }

  public void setSuppHierLvl3(String suppHierLvl3) throws SQLException
  { _struct.setAttribute(16, suppHierLvl3); }


  public String getDefaultUop() throws SQLException
  { return (String) _struct.getAttribute(17); }

  public void setDefaultUop(String defaultUop) throws SQLException
  { _struct.setAttribute(17, defaultUop); }


  public java.math.BigDecimal getSuppPackSize() throws SQLException
  { return (java.math.BigDecimal) _struct.getAttribute(18); }

  public void setSuppPackSize(java.math.BigDecimal suppPackSize) throws SQLException
  { _struct.setAttribute(18, suppPackSize); }


  public java.math.BigDecimal getInnerPackSize() throws SQLException
  { return (java.math.BigDecimal) _struct.getAttribute(19); }

  public void setInnerPackSize(java.math.BigDecimal innerPackSize) throws SQLException
  { _struct.setAttribute(19, innerPackSize); }


  public java.math.BigDecimal getTi() throws SQLException
  { return (java.math.BigDecimal) _struct.getAttribute(20); }

  public void setTi(java.math.BigDecimal ti) throws SQLException
  { _struct.setAttribute(20, ti); }


  public java.math.BigDecimal getHi() throws SQLException
  { return (java.math.BigDecimal) _struct.getAttribute(21); }

  public void setHi(java.math.BigDecimal hi) throws SQLException
  { _struct.setAttribute(21, hi); }


  public RibXiscdimdescTbl getXiscdimdescTbl() throws SQLException
  { return (RibXiscdimdescTbl) _struct.getAttribute(22); }

  public void setXiscdimdescTbl(RibXiscdimdescTbl xiscdimdescTbl) throws SQLException
  { _struct.setAttribute(22, xiscdimdescTbl); }


  public RibExtofxitemsupctydescTbl getExtofxitemsupctydescTbl() throws SQLException
  { return (RibExtofxitemsupctydescTbl) _struct.getAttribute(23); }

  public void setExtofxitemsupctydescTbl(RibExtofxitemsupctydescTbl extofxitemsupctydescTbl) throws SQLException
  { _struct.setAttribute(23, extofxitemsupctydescTbl); }


  public RibXitemsupctydescRec appendnodevalues (
    String I_PREFIX)
  throws java.sql.SQLException
  {
 try {
    RibXitemsupctydescRec __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:268^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n       :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"0oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_XItemSupCtyDesc_REC"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:273^5*/
    return __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    RibXitemsupctydescRec __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:281^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n       :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"1oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_XItemSupCtyDesc_REC"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:286^5*/
    return __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
  }

  public RibObject appendnodevaluesRS (
    String I_PREFIX)
  throws java.sql.SQLException
  {
 try {
    RibObject __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:301^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        I_PREFIX => :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n      I_PREFIX =>  :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"2oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_OBJECT");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_OBJECT"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibObject)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibObject.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:306^5*/
    return __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    RibObject __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:314^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        I_PREFIX => :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n      I_PREFIX =>  :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"3oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_OBJECT");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_OBJECT"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibObject)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibObject.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:319^5*/
    return __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:340^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"4oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:349^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:356^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"5oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:365^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:388^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"6oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:398^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:405^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"7oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:415^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:439^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"8oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:450^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:457^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"9oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:468^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:493^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"10oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:505^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:512^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"11oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:524^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:550^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"12oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:563^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:570^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"13oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:583^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    String SUPP_HIER_LVL_1,
    String SUPP_HIER_LVL_2,
    String SUPP_HIER_LVL_3,
    String DEFAULT_UOP,
    java.math.BigDecimal SUPP_PACK_SIZE,
    java.math.BigDecimal INNER_PACK_SIZE,
    java.math.BigDecimal TI,
    java.math.BigDecimal HI,
    RibXiscdimdescTbl XISCDIMDESC_TBL,
    RibExtofxitemsupctydescTbl EXTOFXITEMSUPCTYDESC_TBL,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:619^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE,
//        :INNER_PACK_SIZE,
//        :TI,
//        :HI,
//        :XISCDIMDESC_TBL,
//        :EXTOFXITEMSUPCTYDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 ,\n       :16 ,\n       :17 ,\n       :18 ,\n       :19 ,\n       :20 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"14oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
   __sJT_st.setBigDecimal(16,INNER_PACK_SIZE);
   __sJT_st.setBigDecimal(17,TI);
   __sJT_st.setBigDecimal(18,HI);
   if (XISCDIMDESC_TBL==null) __sJT_st.setNull(19,2003,"RIB_XISCDimDesc_TBL"); else __sJT_st.setORAData(19,XISCDIMDESC_TBL);
   if (EXTOFXITEMSUPCTYDESC_TBL==null) __sJT_st.setNull(20,2003,"RIB_ExtOfXItemSupCtyDesc_TBL"); else __sJT_st.setORAData(20,EXTOFXITEMSUPCTYDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:642^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:649^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE,
//        :INNER_PACK_SIZE,
//        :TI,
//        :HI,
//        :XISCDIMDESC_TBL,
//        :EXTOFXITEMSUPCTYDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 ,\n       :16 ,\n       :17 ,\n       :18 ,\n       :19 ,\n       :20 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"15oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
   __sJT_st.setBigDecimal(16,INNER_PACK_SIZE);
   __sJT_st.setBigDecimal(17,TI);
   __sJT_st.setBigDecimal(18,HI);
   if (XISCDIMDESC_TBL==null) __sJT_st.setNull(19,2003,"RIB_XISCDimDesc_TBL"); else __sJT_st.setORAData(19,XISCDIMDESC_TBL);
   if (EXTOFXITEMSUPCTYDESC_TBL==null) __sJT_st.setNull(20,2003,"RIB_ExtOfXItemSupCtyDesc_TBL"); else __sJT_st.setORAData(20,EXTOFXITEMSUPCTYDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:672^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    String SUPP_HIER_LVL_1,
    String SUPP_HIER_LVL_2,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:700^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"16oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:715^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:722^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"17oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:737^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    String SUPP_HIER_LVL_1,
    String SUPP_HIER_LVL_2,
    String SUPP_HIER_LVL_3,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:766^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"18oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:782^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:789^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"19oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:805^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    String SUPP_HIER_LVL_1,
    String SUPP_HIER_LVL_2,
    String SUPP_HIER_LVL_3,
    String DEFAULT_UOP,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:835^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"20oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:852^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:859^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"21oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:876^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    String SUPP_HIER_LVL_1,
    String SUPP_HIER_LVL_2,
    String SUPP_HIER_LVL_3,
    String DEFAULT_UOP,
    java.math.BigDecimal SUPP_PACK_SIZE,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:907^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"22oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:925^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:932^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"23oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:950^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    String SUPP_HIER_LVL_1,
    String SUPP_HIER_LVL_2,
    String SUPP_HIER_LVL_3,
    String DEFAULT_UOP,
    java.math.BigDecimal SUPP_PACK_SIZE,
    java.math.BigDecimal INNER_PACK_SIZE,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:982^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE,
//        :INNER_PACK_SIZE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 ,\n       :16 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"24oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
   __sJT_st.setBigDecimal(16,INNER_PACK_SIZE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1001^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:1008^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE,
//        :INNER_PACK_SIZE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 ,\n       :16 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"25oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
   __sJT_st.setBigDecimal(16,INNER_PACK_SIZE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1027^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    String SUPP_HIER_LVL_1,
    String SUPP_HIER_LVL_2,
    String SUPP_HIER_LVL_3,
    String DEFAULT_UOP,
    java.math.BigDecimal SUPP_PACK_SIZE,
    java.math.BigDecimal INNER_PACK_SIZE,
    java.math.BigDecimal TI,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:1060^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE,
//        :INNER_PACK_SIZE,
//        :TI);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 ,\n       :16 ,\n       :17 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"26oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
   __sJT_st.setBigDecimal(16,INNER_PACK_SIZE);
   __sJT_st.setBigDecimal(17,TI);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1080^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:1087^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE,
//        :INNER_PACK_SIZE,
//        :TI);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 ,\n       :16 ,\n       :17 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"27oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
   __sJT_st.setBigDecimal(16,INNER_PACK_SIZE);
   __sJT_st.setBigDecimal(17,TI);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1107^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    String SUPP_HIER_LVL_1,
    String SUPP_HIER_LVL_2,
    String SUPP_HIER_LVL_3,
    String DEFAULT_UOP,
    java.math.BigDecimal SUPP_PACK_SIZE,
    java.math.BigDecimal INNER_PACK_SIZE,
    java.math.BigDecimal TI,
    java.math.BigDecimal HI,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:1141^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE,
//        :INNER_PACK_SIZE,
//        :TI,
//        :HI);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 ,\n       :16 ,\n       :17 ,\n       :18 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"28oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
   __sJT_st.setBigDecimal(16,INNER_PACK_SIZE);
   __sJT_st.setBigDecimal(17,TI);
   __sJT_st.setBigDecimal(18,HI);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1162^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:1169^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE,
//        :INNER_PACK_SIZE,
//        :TI,
//        :HI);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 ,\n       :16 ,\n       :17 ,\n       :18 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"29oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
   __sJT_st.setBigDecimal(16,INNER_PACK_SIZE);
   __sJT_st.setBigDecimal(17,TI);
   __sJT_st.setBigDecimal(18,HI);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1190^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    String SUPP_HIER_LVL_1,
    String SUPP_HIER_LVL_2,
    String SUPP_HIER_LVL_3,
    String DEFAULT_UOP,
    java.math.BigDecimal SUPP_PACK_SIZE,
    java.math.BigDecimal INNER_PACK_SIZE,
    java.math.BigDecimal TI,
    java.math.BigDecimal HI,
    RibXiscdimdescTbl XISCDIMDESC_TBL,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:1225^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE,
//        :INNER_PACK_SIZE,
//        :TI,
//        :HI,
//        :XISCDIMDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 ,\n       :16 ,\n       :17 ,\n       :18 ,\n       :19 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"30oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
   __sJT_st.setBigDecimal(16,INNER_PACK_SIZE);
   __sJT_st.setBigDecimal(17,TI);
   __sJT_st.setBigDecimal(18,HI);
   if (XISCDIMDESC_TBL==null) __sJT_st.setNull(19,2003,"RIB_XISCDimDesc_TBL"); else __sJT_st.setORAData(19,XISCDIMDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1247^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:1254^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1,
//        :SUPP_HIER_LVL_2,
//        :SUPP_HIER_LVL_3,
//        :DEFAULT_UOP,
//        :SUPP_PACK_SIZE,
//        :INNER_PACK_SIZE,
//        :TI,
//        :HI,
//        :XISCDIMDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 ,\n       :12 ,\n       :13 ,\n       :14 ,\n       :15 ,\n       :16 ,\n       :17 ,\n       :18 ,\n       :19 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"31oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
   __sJT_st.setString(12,SUPP_HIER_LVL_2);
   __sJT_st.setString(13,SUPP_HIER_LVL_3);
   __sJT_st.setString(14,DEFAULT_UOP);
   __sJT_st.setBigDecimal(15,SUPP_PACK_SIZE);
   __sJT_st.setBigDecimal(16,INNER_PACK_SIZE);
   __sJT_st.setBigDecimal(17,TI);
   __sJT_st.setBigDecimal(18,HI);
   if (XISCDIMDESC_TBL==null) __sJT_st.setNull(19,2003,"RIB_XISCDimDesc_TBL"); else __sJT_st.setORAData(19,XISCDIMDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1276^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:1297^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"32oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1305^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:1312^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"33oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1320^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:1340^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"34oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1347^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:1354^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"35oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1361^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemsupctydescRec ribXitemsupctydescRec (
    java.math.BigDecimal RIB_OID,
    String ORIGIN_COUNTRY_ID,
    String PRIMARY_COUNTRY_IND,
    java.math.BigDecimal UNIT_COST,
    RibXisclocdescTbl XISCLOCDESC_TBL,
    java.math.BigDecimal LEAD_TIME,
    java.math.BigDecimal PICKUP_LEAD_TIME,
    java.math.BigDecimal MIN_ORDER_QTY,
    java.math.BigDecimal MAX_ORDER_QTY,
    String SUPP_HIER_LVL_1,
    RibXitemsupctydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemsupctydescRec __jPt_temp = (RibXitemsupctydescRec) this;
    RibXitemsupctydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:1388^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"36oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1402^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:1409^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemSupCtyDesc_REC(
//        :RIB_OID,
//        :ORIGIN_COUNTRY_ID,
//        :PRIMARY_COUNTRY_IND,
//        :UNIT_COST,
//        :XISCLOCDESC_TBL,
//        :LEAD_TIME,
//        :PICKUP_LEAD_TIME,
//        :MIN_ORDER_QTY,
//        :MAX_ORDER_QTY,
//        :SUPP_HIER_LVL_1);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemSupCtyDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"37oracle.retail.merch20.microApps.createRegItem.RibXitemsupctydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemSupCtyDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,ORIGIN_COUNTRY_ID);
   __sJT_st.setString(4,PRIMARY_COUNTRY_IND);
   __sJT_st.setBigDecimal(5,UNIT_COST);
   if (XISCLOCDESC_TBL==null) __sJT_st.setNull(6,2003,"RIB_XISCLocDesc_TBL"); else __sJT_st.setORAData(6,XISCLOCDESC_TBL);
   __sJT_st.setBigDecimal(7,LEAD_TIME);
   __sJT_st.setBigDecimal(8,PICKUP_LEAD_TIME);
   __sJT_st.setBigDecimal(9,MIN_ORDER_QTY);
   __sJT_st.setBigDecimal(10,MAX_ORDER_QTY);
   __sJT_st.setString(11,SUPP_HIER_LVL_1);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemsupctydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:1423^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }
}/*@lineinfo:generated-code*/