package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXitemudadtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_XItemUDADtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXitemudadtlTbl _RibXitemudadtlTblFactory = new RibXitemudadtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemudadtlTblFactory; }
  /* constructors */
  public RibXitemudadtlTbl()
  {
    this((RibXitemudadtlRec[])null);
  }

  public RibXitemudadtlTbl(RibXitemudadtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibXitemudadtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__schemaName!=null) return _array.toDatum(c,__schemaName + "." + _SQL_NAME);
    return _array.toDatum(c, _SQL_NAME);
  }
  private String __schemaName = null;
  public void __setSchemaName(String schemaName) { __schemaName = schemaName; }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibXitemudadtlTbl a = new RibXitemudadtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXitemudadtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXitemudadtlRec[] getArray() throws SQLException
  {
    return (RibXitemudadtlRec[]) _array.getObjectArray(
      new RibXitemudadtlRec[_array.length()]);
  }

  public RibXitemudadtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXitemudadtlRec[]) _array.getObjectArray(index,
      new RibXitemudadtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXitemudadtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXitemudadtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXitemudadtlRec getElement(long index) throws SQLException
  {
    return (RibXitemudadtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibXitemudadtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
