/*@lineinfo:filename=RibXitmsupctymfrdescRec*//*@lineinfo:user-code*//*@lineinfo:1^1*/package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.STRUCT;
import oracle.jpub.runtime.MutableStruct;
import sqlj.runtime.ref.DefaultContext;
import sqlj.runtime.ConnectionContext;

public class RibXitmsupctymfrdescRec extends RibObject implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_XItmSupCtyMfrDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.STRUCT;

  protected static int[] _sqlType =  { 2,12,12,12,12,12,12,12,2003 };
  protected static ORADataFactory[] _factory = new ORADataFactory[9];
  static
  {
    _factory[8] = RibExtofxitmsupctymfrdescTbl.getORADataFactory();
  }
  protected static final RibXitmsupctymfrdescRec _RibXitmsupctymfrdescRecFactory = new RibXitmsupctymfrdescRec();

  public static ORADataFactory getORADataFactory()
  { return _RibXitmsupctymfrdescRecFactory; }
  static
  { _map.put("RIB_XItmSupCtyMfrDesc_REC", _RibXitmsupctymfrdescRecFactory); }

  /* constructors */
  protected void _init_struct(boolean init)
  { if (init) _struct = new MutableStruct(new Object[9], _sqlType, _factory); }
  public RibXitmsupctymfrdescRec()
  { _init_struct(true); __tx = DefaultContext.getDefaultContext(); }
  public RibXitmsupctymfrdescRec(DefaultContext c) /*throws SQLException*/
  { _init_struct(true); __tx = c; }
  public RibXitmsupctymfrdescRec(Connection c) /*throws SQLException*/
  { _init_struct(true); __onn = c; }
  public RibXitmsupctymfrdescRec(java.math.BigDecimal ribOid, String nsVersionV1, String nsNameXitmsupctymfrdesc, String nsTypeBo, String nsLocationBase, String nsLevelTop, String manufacturerCtryId, String primaryManufacturerCtryInd, RibExtofxitmsupctymfrdescTbl extofxitmsupctymfrdescTbl) throws SQLException
  {
    _init_struct(true);
    setRibOid(ribOid);
    setNsVersionV1(nsVersionV1);
    setNsNameXitmsupctymfrdesc(nsNameXitmsupctymfrdesc);
    setNsTypeBo(nsTypeBo);
    setNsLocationBase(nsLocationBase);
    setNsLevelTop(nsLevelTop);
    setManufacturerCtryId(manufacturerCtryId);
    setPrimaryManufacturerCtryInd(primaryManufacturerCtryInd);
    setExtofxitmsupctymfrdescTbl(extofxitmsupctymfrdescTbl);
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__tx!=null && __onn!=c) release();
    __onn = c;
    return _struct.toDatum(c, _SQL_NAME);
  }


  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  { return create(null, d, sqlType); }
  public void setFrom(RibXitmsupctymfrdescRec o) throws SQLException
  { setContextFrom(o); setValueFrom(o); }
  protected void setContextFrom(RibXitmsupctymfrdescRec o) throws SQLException
  { release(); __tx = o.__tx; __onn = o.__onn; }
  protected void setValueFrom(RibXitmsupctymfrdescRec o) { _struct = o._struct; }
  protected ORAData create(RibXitmsupctymfrdescRec o, Datum d, int sqlType) throws SQLException
  {
    if (d == null) { if (o!=null) { o.release(); }; return null; }
    if (o == null) o = new RibXitmsupctymfrdescRec();
    o._struct = new MutableStruct((STRUCT) d, _sqlType, _factory);
    o.__onn = ((STRUCT) d).getJavaSqlConnection();
    return o;
  }
  protected ORAData createExact(Datum d, int sqlType) throws SQLException
  { return create(null, d, sqlType); }

  /* accessor methods */
  public String getNsVersionV1() throws SQLException
  { return (String) _struct.getAttribute(1); }

  public void setNsVersionV1(String nsVersionV1) throws SQLException
  { _struct.setAttribute(1, nsVersionV1); }


  public String getNsNameXitmsupctymfrdesc() throws SQLException
  { return (String) _struct.getAttribute(2); }

  public void setNsNameXitmsupctymfrdesc(String nsNameXitmsupctymfrdesc) throws SQLException
  { _struct.setAttribute(2, nsNameXitmsupctymfrdesc); }


  public String getNsTypeBo() throws SQLException
  { return (String) _struct.getAttribute(3); }

  public void setNsTypeBo(String nsTypeBo) throws SQLException
  { _struct.setAttribute(3, nsTypeBo); }


  public String getNsLocationBase() throws SQLException
  { return (String) _struct.getAttribute(4); }

  public void setNsLocationBase(String nsLocationBase) throws SQLException
  { _struct.setAttribute(4, nsLocationBase); }


  public String getNsLevelTop() throws SQLException
  { return (String) _struct.getAttribute(5); }

  public void setNsLevelTop(String nsLevelTop) throws SQLException
  { _struct.setAttribute(5, nsLevelTop); }


  public String getManufacturerCtryId() throws SQLException
  { return (String) _struct.getAttribute(6); }

  public void setManufacturerCtryId(String manufacturerCtryId) throws SQLException
  { _struct.setAttribute(6, manufacturerCtryId); }


  public String getPrimaryManufacturerCtryInd() throws SQLException
  { return (String) _struct.getAttribute(7); }

  public void setPrimaryManufacturerCtryInd(String primaryManufacturerCtryInd) throws SQLException
  { _struct.setAttribute(7, primaryManufacturerCtryInd); }


  public RibExtofxitmsupctymfrdescTbl getExtofxitmsupctymfrdescTbl() throws SQLException
  { return (RibExtofxitmsupctymfrdescTbl) _struct.getAttribute(8); }

  public void setExtofxitmsupctymfrdescTbl(RibExtofxitmsupctymfrdescTbl extofxitmsupctymfrdescTbl) throws SQLException
  { _struct.setAttribute(8, extofxitmsupctymfrdescTbl); }


  public RibObject appendnodevalues (
    String I_PREFIX)
  throws java.sql.SQLException
  {
 try {
    RibObject __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:146^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n       :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"0oracle.retail.merch20.microApps.createRegItem.RibXitmsupctymfrdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_OBJECT");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_OBJECT"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibObject)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibObject.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:151^5*/
    return __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    RibObject __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:159^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n       :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"1oracle.retail.merch20.microApps.createRegItem.RibXitmsupctymfrdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_OBJECT");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_OBJECT"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibObject)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibObject.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:164^5*/
    return __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
  }

  public RibXitmsupctymfrdescRec appendnodevaluesRS (
    String I_PREFIX)
  throws java.sql.SQLException
  {
 try {
    RibXitmsupctymfrdescRec __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:179^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        I_PREFIX => :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n      I_PREFIX =>  :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"2oracle.retail.merch20.microApps.createRegItem.RibXitmsupctymfrdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItmSupCtyMfrDesc_REC");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_XItmSupCtyMfrDesc_REC"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:184^5*/
    return __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    RibXitmsupctymfrdescRec __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:192^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        I_PREFIX => :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n      I_PREFIX =>  :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"3oracle.retail.merch20.microApps.createRegItem.RibXitmsupctymfrdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItmSupCtyMfrDesc_REC");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_XItmSupCtyMfrDesc_REC"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:197^5*/
    return __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
  }

  public RibXitmsupctymfrdescRec ribXitmsupctymfrdescRec (
    java.math.BigDecimal RIB_OID,
    String MANUFACTURER_CTRY_ID,
    String PRIMARY_MANUFACTURER_CTRY_IND,
    RibXitmsupctymfrdescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitmsupctymfrdescRec __jPt_temp = (RibXitmsupctymfrdescRec) this;
    RibXitmsupctymfrdescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:216^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItmSupCtyMfrDesc_REC(
//        :RIB_OID,
//        :MANUFACTURER_CTRY_ID,
//        :PRIMARY_MANUFACTURER_CTRY_IND);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItmSupCtyMfrDesc_REC(\n       :2 ,\n       :3 ,\n       :4 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"4oracle.retail.merch20.microApps.createRegItem.RibXitmsupctymfrdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItmSupCtyMfrDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,MANUFACTURER_CTRY_ID);
   __sJT_st.setString(4,PRIMARY_MANUFACTURER_CTRY_IND);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:223^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:230^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItmSupCtyMfrDesc_REC(
//        :RIB_OID,
//        :MANUFACTURER_CTRY_ID,
//        :PRIMARY_MANUFACTURER_CTRY_IND);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItmSupCtyMfrDesc_REC(\n       :2 ,\n       :3 ,\n       :4 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"5oracle.retail.merch20.microApps.createRegItem.RibXitmsupctymfrdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItmSupCtyMfrDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,MANUFACTURER_CTRY_ID);
   __sJT_st.setString(4,PRIMARY_MANUFACTURER_CTRY_IND);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:237^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitmsupctymfrdescRec ribXitmsupctymfrdescRec (
    java.math.BigDecimal RIB_OID,
    String MANUFACTURER_CTRY_ID,
    String PRIMARY_MANUFACTURER_CTRY_IND,
    RibExtofxitmsupctymfrdescTbl EXTOFXITMSUPCTYMFRDESC_TBL,
    RibXitmsupctymfrdescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitmsupctymfrdescRec __jPt_temp = (RibXitmsupctymfrdescRec) this;
    RibXitmsupctymfrdescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:258^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItmSupCtyMfrDesc_REC(
//        :RIB_OID,
//        :MANUFACTURER_CTRY_ID,
//        :PRIMARY_MANUFACTURER_CTRY_IND,
//        :EXTOFXITMSUPCTYMFRDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItmSupCtyMfrDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"6oracle.retail.merch20.microApps.createRegItem.RibXitmsupctymfrdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItmSupCtyMfrDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,MANUFACTURER_CTRY_ID);
   __sJT_st.setString(4,PRIMARY_MANUFACTURER_CTRY_IND);
   if (EXTOFXITMSUPCTYMFRDESC_TBL==null) __sJT_st.setNull(5,2003,"RIB_ExtOfXItmSupCtyMfrDesc_TBL"); else __sJT_st.setORAData(5,EXTOFXITMSUPCTYMFRDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:266^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:273^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItmSupCtyMfrDesc_REC(
//        :RIB_OID,
//        :MANUFACTURER_CTRY_ID,
//        :PRIMARY_MANUFACTURER_CTRY_IND,
//        :EXTOFXITMSUPCTYMFRDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItmSupCtyMfrDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"7oracle.retail.merch20.microApps.createRegItem.RibXitmsupctymfrdescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItmSupCtyMfrDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,MANUFACTURER_CTRY_ID);
   __sJT_st.setString(4,PRIMARY_MANUFACTURER_CTRY_IND);
   if (EXTOFXITMSUPCTYMFRDESC_TBL==null) __sJT_st.setNull(5,2003,"RIB_ExtOfXItmSupCtyMfrDesc_TBL"); else __sJT_st.setORAData(5,EXTOFXITMSUPCTYMFRDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitmsupctymfrdescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:281^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }
}/*@lineinfo:generated-code*/