package oracle.retail.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXorderdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_XOrderDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXorderdtlTbl _RibXorderdtlTblFactory = new RibXorderdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXorderdtlTblFactory; }
  /* constructors */
  public RibXorderdtlTbl()
  {
    this((RibXorderdtlRec[])null);
  }

  public RibXorderdtlTbl(RibXorderdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibXorderdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibXorderdtlTbl a = new RibXorderdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXorderdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXorderdtlRec[] getArray() throws SQLException
  {
    return (RibXorderdtlRec[]) _array.getObjectArray(
      new RibXorderdtlRec[_array.length()]);
  }

  public RibXorderdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXorderdtlRec[]) _array.getObjectArray(index,
      new RibXorderdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXorderdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXorderdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXorderdtlRec getElement(long index) throws SQLException
  {
    return (RibXorderdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibXorderdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
