package oracle.retail.microapps.map.managed.helper;

import org.junit.Assert;
import org.junit.Test;

public class InContextAppDispatcherTest {
    
    public InContextAppDispatcherTest() {
        super();
    }
    
    @Test
    public void testCreateItemMicroAppID(){
      Assert.assertEquals("/WEB-INF/create-item-flow.xml#create-item-flow", InContextAppDispatcher.getAppTaskFlowID("CREATE_ITEM"));
    }
    
    @Test
    public void testTransferItemMicroAppID(){
      Assert.assertEquals("/WEB-INF/transfer-item-flow.xml#transfer-item-flow", InContextAppDispatcher.getAppTaskFlowID("TRANSFER_ITEM"));
    }
    
    @Test
    public void testOrderItemMicroAppID(){
      Assert.assertEquals("/WEB-INF/create-order-flow.xml#create-order-flow", InContextAppDispatcher.getAppTaskFlowID("ORDER_ITEM"));
    }
}
