package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxitemcostdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXItemCostDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxitemcostdescTbl _RibBrxitemcostdescTblFactory = new RibBrxitemcostdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitemcostdescTblFactory; }
  /* constructors */
  public RibBrxitemcostdescTbl()
  {
    this((RibBrxitemcostdescRec[])null);
  }

  public RibBrxitemcostdescTbl(RibBrxitemcostdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxitemcostdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxitemcostdescTbl a = new RibBrxitemcostdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxitemcostdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxitemcostdescRec[] getArray() throws SQLException
  {
    return (RibBrxitemcostdescRec[]) _array.getObjectArray(
      new RibBrxitemcostdescRec[_array.length()]);
  }

  public RibBrxitemcostdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxitemcostdescRec[]) _array.getObjectArray(index,
      new RibBrxitemcostdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxitemcostdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxitemcostdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxitemcostdescRec getElement(long index) throws SQLException
  {
    return (RibBrxitemcostdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxitemcostdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
