/*@lineinfo:filename=RibBrxitemctrydescRec*//*@lineinfo:user-code*//*@lineinfo:1^1*/package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.STRUCT;
import oracle.jpub.runtime.MutableStruct;
import sqlj.runtime.ref.DefaultContext;
import sqlj.runtime.ConnectionContext;

public class RibBrxitemctrydescRec extends RibObject implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXItemCtryDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.STRUCT;

  protected static int[] _sqlType =  { 2,12,12,12,12,12,12,12,12,12,12,12,12,12,2003 };
  protected static ORADataFactory[] _factory = new ORADataFactory[15];
  static
  {
    _factory[14] = RibEofbrxitemctrydescTbl.getORADataFactory();
  }
  protected static final RibBrxitemctrydescRec _RibBrxitemctrydescRecFactory = new RibBrxitemctrydescRec();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitemctrydescRecFactory; }
  static
  { _map.put("RMS01.RIB_BrXItemCtryDesc_REC", _RibBrxitemctrydescRecFactory); }

  /* constructors */
  protected void _init_struct(boolean init)
  { if (init) _struct = new MutableStruct(new Object[15], _sqlType, _factory); }
  public RibBrxitemctrydescRec()
  { _init_struct(true); __tx = DefaultContext.getDefaultContext(); }
  public RibBrxitemctrydescRec(DefaultContext c) /*throws SQLException*/
  { _init_struct(true); __tx = c; }
  public RibBrxitemctrydescRec(Connection c) /*throws SQLException*/
  { _init_struct(true); __onn = c; }
  public RibBrxitemctrydescRec(java.math.BigDecimal ribOid, String nsVersionV1, String nsNameBrxitemdesc, String nsTypeBo, String nsLocationLocalization, String nsLevelNontop, String serviceInd, String originCode, String classificationId, String ncmCharCode, String exIpi, String pautaCode, String serviceCode, String federalService, RibEofbrxitemctrydescTbl eofbrxitemctrydescTbl) throws SQLException
  {
    _init_struct(true);
    setRibOid(ribOid);
    setNsVersionV1(nsVersionV1);
    setNsNameBrxitemdesc(nsNameBrxitemdesc);
    setNsTypeBo(nsTypeBo);
    setNsLocationLocalization(nsLocationLocalization);
    setNsLevelNontop(nsLevelNontop);
    setServiceInd(serviceInd);
    setOriginCode(originCode);
    setClassificationId(classificationId);
    setNcmCharCode(ncmCharCode);
    setExIpi(exIpi);
    setPautaCode(pautaCode);
    setServiceCode(serviceCode);
    setFederalService(federalService);
    setEofbrxitemctrydescTbl(eofbrxitemctrydescTbl);
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__tx!=null && __onn!=c) release();
    __onn = c;
    return _struct.toDatum(c, _SQL_NAME);
  }


  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  { return create(null, d, sqlType); }
  public void setFrom(RibBrxitemctrydescRec o) throws SQLException
  { setContextFrom(o); setValueFrom(o); }
  protected void setContextFrom(RibBrxitemctrydescRec o) throws SQLException
  { release(); __tx = o.__tx; __onn = o.__onn; }
  protected void setValueFrom(RibBrxitemctrydescRec o) { _struct = o._struct; }
  protected ORAData create(RibBrxitemctrydescRec o, Datum d, int sqlType) throws SQLException
  {
    if (d == null) { if (o!=null) { o.release(); }; return null; }
    if (o == null) o = new RibBrxitemctrydescRec();
    o._struct = new MutableStruct((STRUCT) d, _sqlType, _factory);
    o.__onn = ((STRUCT) d).getJavaSqlConnection();
    return o;
  }
  protected ORAData createExact(Datum d, int sqlType) throws SQLException
  { return create(null, d, sqlType); }

  /* accessor methods */
  public String getNsVersionV1() throws SQLException
  { return (String) _struct.getAttribute(1); }

  public void setNsVersionV1(String nsVersionV1) throws SQLException
  { _struct.setAttribute(1, nsVersionV1); }


  public String getNsNameBrxitemdesc() throws SQLException
  { return (String) _struct.getAttribute(2); }

  public void setNsNameBrxitemdesc(String nsNameBrxitemdesc) throws SQLException
  { _struct.setAttribute(2, nsNameBrxitemdesc); }


  public String getNsTypeBo() throws SQLException
  { return (String) _struct.getAttribute(3); }

  public void setNsTypeBo(String nsTypeBo) throws SQLException
  { _struct.setAttribute(3, nsTypeBo); }


  public String getNsLocationLocalization() throws SQLException
  { return (String) _struct.getAttribute(4); }

  public void setNsLocationLocalization(String nsLocationLocalization) throws SQLException
  { _struct.setAttribute(4, nsLocationLocalization); }


  public String getNsLevelNontop() throws SQLException
  { return (String) _struct.getAttribute(5); }

  public void setNsLevelNontop(String nsLevelNontop) throws SQLException
  { _struct.setAttribute(5, nsLevelNontop); }


  public String getServiceInd() throws SQLException
  { return (String) _struct.getAttribute(6); }

  public void setServiceInd(String serviceInd) throws SQLException
  { _struct.setAttribute(6, serviceInd); }


  public String getOriginCode() throws SQLException
  { return (String) _struct.getAttribute(7); }

  public void setOriginCode(String originCode) throws SQLException
  { _struct.setAttribute(7, originCode); }


  public String getClassificationId() throws SQLException
  { return (String) _struct.getAttribute(8); }

  public void setClassificationId(String classificationId) throws SQLException
  { _struct.setAttribute(8, classificationId); }


  public String getNcmCharCode() throws SQLException
  { return (String) _struct.getAttribute(9); }

  public void setNcmCharCode(String ncmCharCode) throws SQLException
  { _struct.setAttribute(9, ncmCharCode); }


  public String getExIpi() throws SQLException
  { return (String) _struct.getAttribute(10); }

  public void setExIpi(String exIpi) throws SQLException
  { _struct.setAttribute(10, exIpi); }


  public String getPautaCode() throws SQLException
  { return (String) _struct.getAttribute(11); }

  public void setPautaCode(String pautaCode) throws SQLException
  { _struct.setAttribute(11, pautaCode); }


  public String getServiceCode() throws SQLException
  { return (String) _struct.getAttribute(12); }

  public void setServiceCode(String serviceCode) throws SQLException
  { _struct.setAttribute(12, serviceCode); }


  public String getFederalService() throws SQLException
  { return (String) _struct.getAttribute(13); }

  public void setFederalService(String federalService) throws SQLException
  { _struct.setAttribute(13, federalService); }


  public RibEofbrxitemctrydescTbl getEofbrxitemctrydescTbl() throws SQLException
  { return (RibEofbrxitemctrydescTbl) _struct.getAttribute(14); }

  public void setEofbrxitemctrydescTbl(RibEofbrxitemctrydescTbl eofbrxitemctrydescTbl) throws SQLException
  { _struct.setAttribute(14, eofbrxitemctrydescTbl); }


  public RibBrxitemctrydescRec appendnodevalues (
    String I_PREFIX)
  throws java.sql.SQLException
  {
 try {
    RibBrxitemctrydescRec __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:194^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n       :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"0oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:199^5*/
    return __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    RibBrxitemctrydescRec __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:207^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n       :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"1oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:212^5*/
    return __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
  }

  public RibObject appendnodevaluesRS (
    String I_PREFIX)
  throws java.sql.SQLException
  {
 try {
    RibObject __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:227^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        I_PREFIX => :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n      I_PREFIX =>  :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"2oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_OBJECT");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RMS01.RIB_OBJECT"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibObject)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibObject.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:232^5*/
    return __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    RibObject __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:240^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        I_PREFIX => :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n      I_PREFIX =>  :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"3oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_OBJECT");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RMS01.RIB_OBJECT"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibObject)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibObject.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:245^5*/
    return __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
  }

  public RibBrxitemctrydescRec ribBrxitemctrydescRec (
    java.math.BigDecimal RIB_OID,
    String SERVICE_IND,
    String ORIGIN_CODE,
    String CLASSIFICATION_ID,
    RibBrxitemctrydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibBrxitemctrydescRec __jPt_temp = (RibBrxitemctrydescRec) this;
    RibBrxitemctrydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:265^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"4oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:273^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:280^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"5oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:288^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }

  public RibBrxitemctrydescRec ribBrxitemctrydescRec (
    java.math.BigDecimal RIB_OID,
    String SERVICE_IND,
    String ORIGIN_CODE,
    String CLASSIFICATION_ID,
    String NCM_CHAR_CODE,
    String EX_IPI,
    String PAUTA_CODE,
    String SERVICE_CODE,
    String FEDERAL_SERVICE,
    RibEofbrxitemctrydescTbl EOFBRXITEMCTRYDESC_TBL,
    RibBrxitemctrydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibBrxitemctrydescRec __jPt_temp = (RibBrxitemctrydescRec) this;
    RibBrxitemctrydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:315^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE,
//        :EX_IPI,
//        :PAUTA_CODE,
//        :SERVICE_CODE,
//        :FEDERAL_SERVICE,
//        :EOFBRXITEMCTRYDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"6oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
   __sJT_st.setString(7,EX_IPI);
   __sJT_st.setString(8,PAUTA_CODE);
   __sJT_st.setString(9,SERVICE_CODE);
   __sJT_st.setString(10,FEDERAL_SERVICE);
   if (EOFBRXITEMCTRYDESC_TBL==null) __sJT_st.setNull(11,2003,"RMS01.RIB_EOfBrXItemCtryDesc_TBL"); else __sJT_st.setORAData(11,EOFBRXITEMCTRYDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:329^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:336^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE,
//        :EX_IPI,
//        :PAUTA_CODE,
//        :SERVICE_CODE,
//        :FEDERAL_SERVICE,
//        :EOFBRXITEMCTRYDESC_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 ,\n       :11 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"7oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
   __sJT_st.setString(7,EX_IPI);
   __sJT_st.setString(8,PAUTA_CODE);
   __sJT_st.setString(9,SERVICE_CODE);
   __sJT_st.setString(10,FEDERAL_SERVICE);
   if (EOFBRXITEMCTRYDESC_TBL==null) __sJT_st.setNull(11,2003,"RMS01.RIB_EOfBrXItemCtryDesc_TBL"); else __sJT_st.setORAData(11,EOFBRXITEMCTRYDESC_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:350^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }

  public RibBrxitemctrydescRec ribBrxitemctrydescRec (
    java.math.BigDecimal RIB_OID,
    String SERVICE_IND,
    String ORIGIN_CODE,
    String CLASSIFICATION_ID,
    String NCM_CHAR_CODE,
    String EX_IPI,
    RibBrxitemctrydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibBrxitemctrydescRec __jPt_temp = (RibBrxitemctrydescRec) this;
    RibBrxitemctrydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:373^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE,
//        :EX_IPI);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"8oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
   __sJT_st.setString(7,EX_IPI);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:383^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:390^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE,
//        :EX_IPI);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"9oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
   __sJT_st.setString(7,EX_IPI);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:400^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }

  public RibBrxitemctrydescRec ribBrxitemctrydescRec (
    java.math.BigDecimal RIB_OID,
    String SERVICE_IND,
    String ORIGIN_CODE,
    String CLASSIFICATION_ID,
    String NCM_CHAR_CODE,
    String EX_IPI,
    String PAUTA_CODE,
    RibBrxitemctrydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibBrxitemctrydescRec __jPt_temp = (RibBrxitemctrydescRec) this;
    RibBrxitemctrydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:424^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE,
//        :EX_IPI,
//        :PAUTA_CODE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"10oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
   __sJT_st.setString(7,EX_IPI);
   __sJT_st.setString(8,PAUTA_CODE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:435^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:442^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE,
//        :EX_IPI,
//        :PAUTA_CODE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"11oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
   __sJT_st.setString(7,EX_IPI);
   __sJT_st.setString(8,PAUTA_CODE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:453^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }

  public RibBrxitemctrydescRec ribBrxitemctrydescRec (
    java.math.BigDecimal RIB_OID,
    String SERVICE_IND,
    String ORIGIN_CODE,
    String CLASSIFICATION_ID,
    String NCM_CHAR_CODE,
    String EX_IPI,
    String PAUTA_CODE,
    String SERVICE_CODE,
    RibBrxitemctrydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibBrxitemctrydescRec __jPt_temp = (RibBrxitemctrydescRec) this;
    RibBrxitemctrydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:478^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE,
//        :EX_IPI,
//        :PAUTA_CODE,
//        :SERVICE_CODE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"12oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
   __sJT_st.setString(7,EX_IPI);
   __sJT_st.setString(8,PAUTA_CODE);
   __sJT_st.setString(9,SERVICE_CODE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:490^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:497^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE,
//        :EX_IPI,
//        :PAUTA_CODE,
//        :SERVICE_CODE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"13oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
   __sJT_st.setString(7,EX_IPI);
   __sJT_st.setString(8,PAUTA_CODE);
   __sJT_st.setString(9,SERVICE_CODE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:509^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }

  public RibBrxitemctrydescRec ribBrxitemctrydescRec (
    java.math.BigDecimal RIB_OID,
    String SERVICE_IND,
    String ORIGIN_CODE,
    String CLASSIFICATION_ID,
    String NCM_CHAR_CODE,
    String EX_IPI,
    String PAUTA_CODE,
    String SERVICE_CODE,
    String FEDERAL_SERVICE,
    RibBrxitemctrydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibBrxitemctrydescRec __jPt_temp = (RibBrxitemctrydescRec) this;
    RibBrxitemctrydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:535^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE,
//        :EX_IPI,
//        :PAUTA_CODE,
//        :SERVICE_CODE,
//        :FEDERAL_SERVICE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"14oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
   __sJT_st.setString(7,EX_IPI);
   __sJT_st.setString(8,PAUTA_CODE);
   __sJT_st.setString(9,SERVICE_CODE);
   __sJT_st.setString(10,FEDERAL_SERVICE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:548^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:555^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE,
//        :EX_IPI,
//        :PAUTA_CODE,
//        :SERVICE_CODE,
//        :FEDERAL_SERVICE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 ,\n       :10 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"15oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
   __sJT_st.setString(7,EX_IPI);
   __sJT_st.setString(8,PAUTA_CODE);
   __sJT_st.setString(9,SERVICE_CODE);
   __sJT_st.setString(10,FEDERAL_SERVICE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:568^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }

  public RibBrxitemctrydescRec ribBrxitemctrydescRec (
    java.math.BigDecimal RIB_OID,
    String SERVICE_IND,
    String ORIGIN_CODE,
    RibBrxitemctrydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibBrxitemctrydescRec __jPt_temp = (RibBrxitemctrydescRec) this;
    RibBrxitemctrydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:588^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"16oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:595^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:602^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"17oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:609^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }

  public RibBrxitemctrydescRec ribBrxitemctrydescRec (
    java.math.BigDecimal RIB_OID,
    String SERVICE_IND,
    RibBrxitemctrydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibBrxitemctrydescRec __jPt_temp = (RibBrxitemctrydescRec) this;
    RibBrxitemctrydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:628^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"18oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:634^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:641^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"19oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:647^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }

  public RibBrxitemctrydescRec ribBrxitemctrydescRec (
    java.math.BigDecimal RIB_OID,
    String SERVICE_IND,
    String ORIGIN_CODE,
    String CLASSIFICATION_ID,
    String NCM_CHAR_CODE,
    RibBrxitemctrydescRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibBrxitemctrydescRec __jPt_temp = (RibBrxitemctrydescRec) this;
    RibBrxitemctrydescRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:669^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"20oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:678^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:685^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_BrXItemCtryDesc_REC(
//        :RIB_OID,
//        :SERVICE_IND,
//        :ORIGIN_CODE,
//        :CLASSIFICATION_ID,
//        :NCM_CHAR_CODE);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_BrXItemCtryDesc_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"21oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RMS01.RIB_BrXItemCtryDesc_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,SERVICE_IND);
   __sJT_st.setString(4,ORIGIN_CODE);
   __sJT_st.setString(5,CLASSIFICATION_ID);
   __sJT_st.setString(6,NCM_CHAR_CODE);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec)__sJT_st.getORAData(1,oracle.retail.microapps.item.ribtypes.RibBrxitemctrydescRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:694^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) { 
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err; 
  }
 }
    return __jPt_result;
  }
}/*@lineinfo:generated-code*/