package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxitemctrydescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXItemCtryDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxitemctrydescTbl _RibBrxitemctrydescTblFactory = new RibBrxitemctrydescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitemctrydescTblFactory; }
  /* constructors */
  public RibBrxitemctrydescTbl()
  {
    this((RibBrxitemctrydescRec[])null);
  }

  public RibBrxitemctrydescTbl(RibBrxitemctrydescRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxitemctrydescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxitemctrydescTbl a = new RibBrxitemctrydescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxitemctrydescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxitemctrydescRec[] getArray() throws SQLException
  {
    return (RibBrxitemctrydescRec[]) _array.getObjectArray(
      new RibBrxitemctrydescRec[_array.length()]);
  }

  public RibBrxitemctrydescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxitemctrydescRec[]) _array.getObjectArray(index,
      new RibBrxitemctrydescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxitemctrydescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxitemctrydescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxitemctrydescRec getElement(long index) throws SQLException
  {
    return (RibBrxitemctrydescRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxitemctrydescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
