package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxitemdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXItemDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxitemdescTbl _RibBrxitemdescTblFactory = new RibBrxitemdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitemdescTblFactory; }
  /* constructors */
  public RibBrxitemdescTbl()
  {
    this((RibBrxitemdescRec[])null);
  }

  public RibBrxitemdescTbl(RibBrxitemdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxitemdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxitemdescTbl a = new RibBrxitemdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxitemdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxitemdescRec[] getArray() throws SQLException
  {
    return (RibBrxitemdescRec[]) _array.getObjectArray(
      new RibBrxitemdescRec[_array.length()]);
  }

  public RibBrxitemdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxitemdescRec[]) _array.getObjectArray(index,
      new RibBrxitemdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxitemdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxitemdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxitemdescRec getElement(long index) throws SQLException
  {
    return (RibBrxitemdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxitemdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
