package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxitemimageTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXItemImage_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxitemimageTbl _RibBrxitemimageTblFactory = new RibBrxitemimageTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitemimageTblFactory; }
  /* constructors */
  public RibBrxitemimageTbl()
  {
    this((RibBrxitemimageRec[])null);
  }

  public RibBrxitemimageTbl(RibBrxitemimageRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxitemimageRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxitemimageTbl a = new RibBrxitemimageTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxitemimageRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxitemimageRec[] getArray() throws SQLException
  {
    return (RibBrxitemimageRec[]) _array.getObjectArray(
      new RibBrxitemimageRec[_array.length()]);
  }

  public RibBrxitemimageRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxitemimageRec[]) _array.getObjectArray(index,
      new RibBrxitemimageRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxitemimageRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxitemimageRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxitemimageRec getElement(long index) throws SQLException
  {
    return (RibBrxitemimageRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxitemimageRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
