package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxitemsupdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXItemSupDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxitemsupdescTbl _RibBrxitemsupdescTblFactory = new RibBrxitemsupdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitemsupdescTblFactory; }
  /* constructors */
  public RibBrxitemsupdescTbl()
  {
    this((RibBrxitemsupdescRec[])null);
  }

  public RibBrxitemsupdescTbl(RibBrxitemsupdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxitemsupdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxitemsupdescTbl a = new RibBrxitemsupdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxitemsupdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxitemsupdescRec[] getArray() throws SQLException
  {
    return (RibBrxitemsupdescRec[]) _array.getObjectArray(
      new RibBrxitemsupdescRec[_array.length()]);
  }

  public RibBrxitemsupdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxitemsupdescRec[]) _array.getObjectArray(index,
      new RibBrxitemsupdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxitemsupdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxitemsupdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxitemsupdescRec getElement(long index) throws SQLException
  {
    return (RibBrxitemsupdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxitemsupdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
