package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibBrxitemvatdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_BrXItemVATDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibBrxitemvatdescTbl _RibBrxitemvatdescTblFactory = new RibBrxitemvatdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibBrxitemvatdescTblFactory; }
  /* constructors */
  public RibBrxitemvatdescTbl()
  {
    this((RibBrxitemvatdescRec[])null);
  }

  public RibBrxitemvatdescTbl(RibBrxitemvatdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibBrxitemvatdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibBrxitemvatdescTbl a = new RibBrxitemvatdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibBrxitemvatdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibBrxitemvatdescRec[] getArray() throws SQLException
  {
    return (RibBrxitemvatdescRec[]) _array.getObjectArray(
      new RibBrxitemvatdescRec[_array.length()]);
  }

  public RibBrxitemvatdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibBrxitemvatdescRec[]) _array.getObjectArray(index,
      new RibBrxitemvatdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibBrxitemvatdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibBrxitemvatdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibBrxitemvatdescRec getElement(long index) throws SQLException
  {
    return (RibBrxitemvatdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibBrxitemvatdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
