package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibEofbrxiscdimdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_EOfBrXISCDimDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibEofbrxiscdimdescRecRef _RibEofbrxiscdimdescRecRefFactory = new RibEofbrxiscdimdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxiscdimdescRecRefFactory; }
  /* constructor */
  public RibEofbrxiscdimdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxiscdimdescRecRef r = new RibEofbrxiscdimdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibEofbrxiscdimdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibEofbrxiscdimdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibEofbrxiscdimdescRecRef: "+exn.toString()); }
  }

  public RibEofbrxiscdimdescRec getValue() throws SQLException
  {
     return (RibEofbrxiscdimdescRec) RibEofbrxiscdimdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibEofbrxiscdimdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
