package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxiscdimdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXISCDimDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxiscdimdescTbl _RibEofbrxiscdimdescTblFactory = new RibEofbrxiscdimdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxiscdimdescTblFactory; }
  /* constructors */
  public RibEofbrxiscdimdescTbl()
  {
    this((RibEofbrxiscdimdescRec[])null);
  }

  public RibEofbrxiscdimdescTbl(RibEofbrxiscdimdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxiscdimdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxiscdimdescTbl a = new RibEofbrxiscdimdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxiscdimdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxiscdimdescRec[] getArray() throws SQLException
  {
    return (RibEofbrxiscdimdescRec[]) _array.getObjectArray(
      new RibEofbrxiscdimdescRec[_array.length()]);
  }

  public RibEofbrxiscdimdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxiscdimdescRec[]) _array.getObjectArray(index,
      new RibEofbrxiscdimdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxiscdimdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxiscdimdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxiscdimdescRec getElement(long index) throws SQLException
  {
    return (RibEofbrxiscdimdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxiscdimdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
