package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxitembomdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXItemBOMDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxitembomdescTbl _RibEofbrxitembomdescTblFactory = new RibEofbrxitembomdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxitembomdescTblFactory; }
  /* constructors */
  public RibEofbrxitembomdescTbl()
  {
    this((RibEofbrxitembomdescRec[])null);
  }

  public RibEofbrxitembomdescTbl(RibEofbrxitembomdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxitembomdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxitembomdescTbl a = new RibEofbrxitembomdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxitembomdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxitembomdescRec[] getArray() throws SQLException
  {
    return (RibEofbrxitembomdescRec[]) _array.getObjectArray(
      new RibEofbrxitembomdescRec[_array.length()]);
  }

  public RibEofbrxitembomdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxitembomdescRec[]) _array.getObjectArray(index,
      new RibEofbrxitembomdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxitembomdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxitembomdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxitembomdescRec getElement(long index) throws SQLException
  {
    return (RibEofbrxitembomdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxitembomdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
