package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxitemcostdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXItemCostDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxitemcostdescTbl _RibEofbrxitemcostdescTblFactory = new RibEofbrxitemcostdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxitemcostdescTblFactory; }
  /* constructors */
  public RibEofbrxitemcostdescTbl()
  {
    this((RibEofbrxitemcostdescRec[])null);
  }

  public RibEofbrxitemcostdescTbl(RibEofbrxitemcostdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxitemcostdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxitemcostdescTbl a = new RibEofbrxitemcostdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxitemcostdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxitemcostdescRec[] getArray() throws SQLException
  {
    return (RibEofbrxitemcostdescRec[]) _array.getObjectArray(
      new RibEofbrxitemcostdescRec[_array.length()]);
  }

  public RibEofbrxitemcostdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxitemcostdescRec[]) _array.getObjectArray(index,
      new RibEofbrxitemcostdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxitemcostdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxitemcostdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxitemcostdescRec getElement(long index) throws SQLException
  {
    return (RibEofbrxitemcostdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxitemcostdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
