package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxizpdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXIZPDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxizpdescTbl _RibEofbrxizpdescTblFactory = new RibEofbrxizpdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxizpdescTblFactory; }
  /* constructors */
  public RibEofbrxizpdescTbl()
  {
    this((RibEofbrxizpdescRec[])null);
  }

  public RibEofbrxizpdescTbl(RibEofbrxizpdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxizpdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxizpdescTbl a = new RibEofbrxizpdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxizpdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxizpdescRec[] getArray() throws SQLException
  {
    return (RibEofbrxizpdescRec[]) _array.getObjectArray(
      new RibEofbrxizpdescRec[_array.length()]);
  }

  public RibEofbrxizpdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxizpdescRec[]) _array.getObjectArray(index,
      new RibEofbrxizpdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxizpdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxizpdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxizpdescRec getElement(long index) throws SQLException
  {
    return (RibEofbrxizpdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxizpdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
