package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxtsfdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXTsfDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxtsfdtlTbl _RibEofbrxtsfdtlTblFactory = new RibEofbrxtsfdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxtsfdtlTblFactory; }
  /* constructors */
  public RibEofbrxtsfdtlTbl()
  {
    this((RibEofbrxtsfdtlRec[])null);
  }

  public RibEofbrxtsfdtlTbl(RibEofbrxtsfdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxtsfdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxtsfdtlTbl a = new RibEofbrxtsfdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxtsfdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxtsfdtlRec[] getArray() throws SQLException
  {
    return (RibEofbrxtsfdtlRec[]) _array.getObjectArray(
      new RibEofbrxtsfdtlRec[_array.length()]);
  }

  public RibEofbrxtsfdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxtsfdtlRec[]) _array.getObjectArray(index,
      new RibEofbrxtsfdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxtsfdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxtsfdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxtsfdtlRec getElement(long index) throws SQLException
  {
    return (RibEofbrxtsfdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxtsfdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
