package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxiscdimdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXISCDimDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxiscdimdescTbl _RibEofinxiscdimdescTblFactory = new RibEofinxiscdimdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxiscdimdescTblFactory; }
  /* constructors */
  public RibEofinxiscdimdescTbl()
  {
    this((RibEofinxiscdimdescRec[])null);
  }

  public RibEofinxiscdimdescTbl(RibEofinxiscdimdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxiscdimdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxiscdimdescTbl a = new RibEofinxiscdimdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxiscdimdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxiscdimdescRec[] getArray() throws SQLException
  {
    return (RibEofinxiscdimdescRec[]) _array.getObjectArray(
      new RibEofinxiscdimdescRec[_array.length()]);
  }

  public RibEofinxiscdimdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxiscdimdescRec[]) _array.getObjectArray(index,
      new RibEofinxiscdimdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxiscdimdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxiscdimdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxiscdimdescRec getElement(long index) throws SQLException
  {
    return (RibEofinxiscdimdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxiscdimdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
