package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxisclocdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXISCLocDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxisclocdescTbl _RibEofinxisclocdescTblFactory = new RibEofinxisclocdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxisclocdescTblFactory; }
  /* constructors */
  public RibEofinxisclocdescTbl()
  {
    this((RibEofinxisclocdescRec[])null);
  }

  public RibEofinxisclocdescTbl(RibEofinxisclocdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxisclocdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxisclocdescTbl a = new RibEofinxisclocdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxisclocdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxisclocdescRec[] getArray() throws SQLException
  {
    return (RibEofinxisclocdescRec[]) _array.getObjectArray(
      new RibEofinxisclocdescRec[_array.length()]);
  }

  public RibEofinxisclocdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxisclocdescRec[]) _array.getObjectArray(index,
      new RibEofinxisclocdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxisclocdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxisclocdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxisclocdescRec getElement(long index) throws SQLException
  {
    return (RibEofinxisclocdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxisclocdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
