package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxitembomdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXItemBOMDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxitembomdescTbl _RibEofinxitembomdescTblFactory = new RibEofinxitembomdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxitembomdescTblFactory; }
  /* constructors */
  public RibEofinxitembomdescTbl()
  {
    this((RibEofinxitembomdescRec[])null);
  }

  public RibEofinxitembomdescTbl(RibEofinxitembomdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxitembomdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxitembomdescTbl a = new RibEofinxitembomdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxitembomdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxitembomdescRec[] getArray() throws SQLException
  {
    return (RibEofinxitembomdescRec[]) _array.getObjectArray(
      new RibEofinxitembomdescRec[_array.length()]);
  }

  public RibEofinxitembomdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxitembomdescRec[]) _array.getObjectArray(index,
      new RibEofinxitembomdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxitembomdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxitembomdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxitembomdescRec getElement(long index) throws SQLException
  {
    return (RibEofinxitembomdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxitembomdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
