package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxitemcostdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXItemCostDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxitemcostdescTbl _RibEofinxitemcostdescTblFactory = new RibEofinxitemcostdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxitemcostdescTblFactory; }
  /* constructors */
  public RibEofinxitemcostdescTbl()
  {
    this((RibEofinxitemcostdescRec[])null);
  }

  public RibEofinxitemcostdescTbl(RibEofinxitemcostdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxitemcostdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxitemcostdescTbl a = new RibEofinxitemcostdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxitemcostdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxitemcostdescRec[] getArray() throws SQLException
  {
    return (RibEofinxitemcostdescRec[]) _array.getObjectArray(
      new RibEofinxitemcostdescRec[_array.length()]);
  }

  public RibEofinxitemcostdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxitemcostdescRec[]) _array.getObjectArray(index,
      new RibEofinxitemcostdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxitemcostdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxitemcostdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxitemcostdescRec getElement(long index) throws SQLException
  {
    return (RibEofinxitemcostdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxitemcostdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
