package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxitemimageTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXItemImage_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxitemimageTbl _RibEofinxitemimageTblFactory = new RibEofinxitemimageTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxitemimageTblFactory; }
  /* constructors */
  public RibEofinxitemimageTbl()
  {
    this((RibEofinxitemimageRec[])null);
  }

  public RibEofinxitemimageTbl(RibEofinxitemimageRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxitemimageRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxitemimageTbl a = new RibEofinxitemimageTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxitemimageRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxitemimageRec[] getArray() throws SQLException
  {
    return (RibEofinxitemimageRec[]) _array.getObjectArray(
      new RibEofinxitemimageRec[_array.length()]);
  }

  public RibEofinxitemimageRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxitemimageRec[]) _array.getObjectArray(index,
      new RibEofinxitemimageRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxitemimageRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxitemimageRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxitemimageRec getElement(long index) throws SQLException
  {
    return (RibEofinxitemimageRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxitemimageRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
