package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxitemudadtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXItemUDADtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxitemudadtlTbl _RibEofinxitemudadtlTblFactory = new RibEofinxitemudadtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxitemudadtlTblFactory; }
  /* constructors */
  public RibEofinxitemudadtlTbl()
  {
    this((RibEofinxitemudadtlRec[])null);
  }

  public RibEofinxitemudadtlTbl(RibEofinxitemudadtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxitemudadtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxitemudadtlTbl a = new RibEofinxitemudadtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxitemudadtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxitemudadtlRec[] getArray() throws SQLException
  {
    return (RibEofinxitemudadtlRec[]) _array.getObjectArray(
      new RibEofinxitemudadtlRec[_array.length()]);
  }

  public RibEofinxitemudadtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxitemudadtlRec[]) _array.getObjectArray(index,
      new RibEofinxitemudadtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxitemudadtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxitemudadtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxitemudadtlRec getElement(long index) throws SQLException
  {
    return (RibEofinxitemudadtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxitemudadtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
