package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxitemvatdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXItemVATDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxitemvatdescTbl _RibEofinxitemvatdescTblFactory = new RibEofinxitemvatdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxitemvatdescTblFactory; }
  /* constructors */
  public RibEofinxitemvatdescTbl()
  {
    this((RibEofinxitemvatdescRec[])null);
  }

  public RibEofinxitemvatdescTbl(RibEofinxitemvatdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxitemvatdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxitemvatdescTbl a = new RibEofinxitemvatdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxitemvatdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxitemvatdescRec[] getArray() throws SQLException
  {
    return (RibEofinxitemvatdescRec[]) _array.getObjectArray(
      new RibEofinxitemvatdescRec[_array.length()]);
  }

  public RibEofinxitemvatdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxitemvatdescRec[]) _array.getObjectArray(index,
      new RibEofinxitemvatdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxitemvatdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxitemvatdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxitemvatdescRec getElement(long index) throws SQLException
  {
    return (RibEofinxitemvatdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxitemvatdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
