package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxtsfdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXTsfDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxtsfdtlTbl _RibEofinxtsfdtlTblFactory = new RibEofinxtsfdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxtsfdtlTblFactory; }
  /* constructors */
  public RibEofinxtsfdtlTbl()
  {
    this((RibEofinxtsfdtlRec[])null);
  }

  public RibEofinxtsfdtlTbl(RibEofinxtsfdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxtsfdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxtsfdtlTbl a = new RibEofinxtsfdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxtsfdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxtsfdtlRec[] getArray() throws SQLException
  {
    return (RibEofinxtsfdtlRec[]) _array.getObjectArray(
      new RibEofinxtsfdtlRec[_array.length()]);
  }

  public RibEofinxtsfdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxtsfdtlRec[]) _array.getObjectArray(index,
      new RibEofinxtsfdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxtsfdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxtsfdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxtsfdtlRec getElement(long index) throws SQLException
  {
    return (RibEofinxtsfdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxtsfdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
