package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxiscdimdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_ExtOfXISCDimDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxiscdimdescTbl _RibExtofxiscdimdescTblFactory = new RibExtofxiscdimdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxiscdimdescTblFactory; }
  /* constructors */
  public RibExtofxiscdimdescTbl()
  {
    this((RibExtofxiscdimdescRec[])null);
  }

  public RibExtofxiscdimdescTbl(RibExtofxiscdimdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxiscdimdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibExtofxiscdimdescTbl a = new RibExtofxiscdimdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxiscdimdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxiscdimdescRec[] getArray() throws SQLException
  {
    return (RibExtofxiscdimdescRec[]) _array.getObjectArray(
      new RibExtofxiscdimdescRec[_array.length()]);
  }

  public RibExtofxiscdimdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxiscdimdescRec[]) _array.getObjectArray(index,
      new RibExtofxiscdimdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxiscdimdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxiscdimdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxiscdimdescRec getElement(long index) throws SQLException
  {
    return (RibExtofxiscdimdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxiscdimdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
