package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibExtofxitemctrydescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_ExtOfXItemCtryDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibExtofxitemctrydescRecRef _RibExtofxitemctrydescRecRefFactory = new RibExtofxitemctrydescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemctrydescRecRefFactory; }
  /* constructor */
  public RibExtofxitemctrydescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibExtofxitemctrydescRecRef r = new RibExtofxitemctrydescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibExtofxitemctrydescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibExtofxitemctrydescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibExtofxitemctrydescRecRef: "+exn.toString()); }
  }

  public RibExtofxitemctrydescRec getValue() throws SQLException
  {
     return (RibExtofxitemctrydescRec) RibExtofxitemctrydescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibExtofxitemctrydescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
