package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxitemctrydescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_ExtOfXItemCtryDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxitemctrydescTbl _RibExtofxitemctrydescTblFactory = new RibExtofxitemctrydescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemctrydescTblFactory; }
  /* constructors */
  public RibExtofxitemctrydescTbl()
  {
    this((RibExtofxitemctrydescRec[])null);
  }

  public RibExtofxitemctrydescTbl(RibExtofxitemctrydescRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxitemctrydescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibExtofxitemctrydescTbl a = new RibExtofxitemctrydescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxitemctrydescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxitemctrydescRec[] getArray() throws SQLException
  {
    return (RibExtofxitemctrydescRec[]) _array.getObjectArray(
      new RibExtofxitemctrydescRec[_array.length()]);
  }

  public RibExtofxitemctrydescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxitemctrydescRec[]) _array.getObjectArray(index,
      new RibExtofxitemctrydescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxitemctrydescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxitemctrydescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxitemctrydescRec getElement(long index) throws SQLException
  {
    return (RibExtofxitemctrydescRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxitemctrydescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
