package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibExtofxitemseasonRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_ExtOfXItemSeason_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibExtofxitemseasonRecRef _RibExtofxitemseasonRecRefFactory = new RibExtofxitemseasonRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemseasonRecRefFactory; }
  /* constructor */
  public RibExtofxitemseasonRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibExtofxitemseasonRecRef r = new RibExtofxitemseasonRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibExtofxitemseasonRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibExtofxitemseasonRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibExtofxitemseasonRecRef: "+exn.toString()); }
  }

  public RibExtofxitemseasonRec getValue() throws SQLException
  {
     return (RibExtofxitemseasonRec) RibExtofxitemseasonRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibExtofxitemseasonRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
