package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxitemudadtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_ExtOfXItemUDADtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxitemudadtlTbl _RibExtofxitemudadtlTblFactory = new RibExtofxitemudadtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitemudadtlTblFactory; }
  /* constructors */
  public RibExtofxitemudadtlTbl()
  {
    this((RibExtofxitemudadtlRec[])null);
  }

  public RibExtofxitemudadtlTbl(RibExtofxitemudadtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxitemudadtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibExtofxitemudadtlTbl a = new RibExtofxitemudadtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxitemudadtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxitemudadtlRec[] getArray() throws SQLException
  {
    return (RibExtofxitemudadtlRec[]) _array.getObjectArray(
      new RibExtofxitemudadtlRec[_array.length()]);
  }

  public RibExtofxitemudadtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxitemudadtlRec[]) _array.getObjectArray(index,
      new RibExtofxitemudadtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxitemudadtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxitemudadtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxitemudadtlRec getElement(long index) throws SQLException
  {
    return (RibExtofxitemudadtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxitemudadtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
