package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxitemcostdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXItemCostDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxitemcostdescTbl _RibInxitemcostdescTblFactory = new RibInxitemcostdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitemcostdescTblFactory; }
  /* constructors */
  public RibInxitemcostdescTbl()
  {
    this((RibInxitemcostdescRec[])null);
  }

  public RibInxitemcostdescTbl(RibInxitemcostdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxitemcostdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitemcostdescTbl a = new RibInxitemcostdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxitemcostdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxitemcostdescRec[] getArray() throws SQLException
  {
    return (RibInxitemcostdescRec[]) _array.getObjectArray(
      new RibInxitemcostdescRec[_array.length()]);
  }

  public RibInxitemcostdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxitemcostdescRec[]) _array.getObjectArray(index,
      new RibInxitemcostdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxitemcostdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxitemcostdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxitemcostdescRec getElement(long index) throws SQLException
  {
    return (RibInxitemcostdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxitemcostdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
