package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxitemseasonTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXItemSeason_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxitemseasonTbl _RibInxitemseasonTblFactory = new RibInxitemseasonTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitemseasonTblFactory; }
  /* constructors */
  public RibInxitemseasonTbl()
  {
    this((RibInxitemseasonRec[])null);
  }

  public RibInxitemseasonTbl(RibInxitemseasonRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxitemseasonRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitemseasonTbl a = new RibInxitemseasonTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxitemseasonRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxitemseasonRec[] getArray() throws SQLException
  {
    return (RibInxitemseasonRec[]) _array.getObjectArray(
      new RibInxitemseasonRec[_array.length()]);
  }

  public RibInxitemseasonRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxitemseasonRec[]) _array.getObjectArray(index,
      new RibInxitemseasonRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxitemseasonRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxitemseasonRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxitemseasonRec getElement(long index) throws SQLException
  {
    return (RibInxitemseasonRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxitemseasonRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
