package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibInxitemudadtlRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_InXItemUDADtl_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibInxitemudadtlRecRef _RibInxitemudadtlRecRefFactory = new RibInxitemudadtlRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitemudadtlRecRefFactory; }
  /* constructor */
  public RibInxitemudadtlRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitemudadtlRecRef r = new RibInxitemudadtlRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibInxitemudadtlRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibInxitemudadtlRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibInxitemudadtlRecRef: "+exn.toString()); }
  }

  public RibInxitemudadtlRec getValue() throws SQLException
  {
     return (RibInxitemudadtlRec) RibInxitemudadtlRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibInxitemudadtlRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
