package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibInxitemvatdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_InXItemVATDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibInxitemvatdescRecRef _RibInxitemvatdescRecRefFactory = new RibInxitemvatdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitemvatdescRecRefFactory; }
  /* constructor */
  public RibInxitemvatdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitemvatdescRecRef r = new RibInxitemvatdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibInxitemvatdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibInxitemvatdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibInxitemvatdescRecRef: "+exn.toString()); }
  }

  public RibInxitemvatdescRec getValue() throws SQLException
  {
     return (RibInxitemvatdescRec) RibInxitemvatdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibInxitemvatdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
