package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibInxitemvatdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_InXItemVATDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibInxitemvatdescTbl _RibInxitemvatdescTblFactory = new RibInxitemvatdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibInxitemvatdescTblFactory; }
  /* constructors */
  public RibInxitemvatdescTbl()
  {
    this((RibInxitemvatdescRec[])null);
  }

  public RibInxitemvatdescTbl(RibInxitemvatdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibInxitemvatdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxitemvatdescTbl a = new RibInxitemvatdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibInxitemvatdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibInxitemvatdescRec[] getArray() throws SQLException
  {
    return (RibInxitemvatdescRec[]) _array.getObjectArray(
      new RibInxitemvatdescRec[_array.length()]);
  }

  public RibInxitemvatdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibInxitemvatdescRec[]) _array.getObjectArray(index,
      new RibInxitemvatdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibInxitemvatdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibInxitemvatdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibInxitemvatdescRec getElement(long index) throws SQLException
  {
    return (RibInxitemvatdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibInxitemvatdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
