package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxisclocdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXISCLocDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxisclocdescTbl _RibLocofxisclocdescTblFactory = new RibLocofxisclocdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxisclocdescTblFactory; }
  /* constructors */
  public RibLocofxisclocdescTbl()
  {
    this((RibLocofxisclocdescRec[])null);
  }

  public RibLocofxisclocdescTbl(RibLocofxisclocdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxisclocdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxisclocdescTbl a = new RibLocofxisclocdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxisclocdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxisclocdescRec[] getArray() throws SQLException
  {
    return (RibLocofxisclocdescRec[]) _array.getObjectArray(
      new RibLocofxisclocdescRec[_array.length()]);
  }

  public RibLocofxisclocdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxisclocdescRec[]) _array.getObjectArray(index,
      new RibLocofxisclocdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxisclocdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxisclocdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxisclocdescRec getElement(long index) throws SQLException
  {
    return (RibLocofxisclocdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxisclocdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
