package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibLocofxitembomdescRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_LocOfXItemBOMDesc_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibLocofxitembomdescRecRef _RibLocofxitembomdescRecRefFactory = new RibLocofxitembomdescRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxitembomdescRecRefFactory; }
  /* constructor */
  public RibLocofxitembomdescRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxitembomdescRecRef r = new RibLocofxitembomdescRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibLocofxitembomdescRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibLocofxitembomdescRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibLocofxitembomdescRecRef: "+exn.toString()); }
  }

  public RibLocofxitembomdescRec getValue() throws SQLException
  {
     return (RibLocofxitembomdescRec) RibLocofxitembomdescRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibLocofxitembomdescRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
