package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxitemcostdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXItemCostDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxitemcostdescTbl _RibLocofxitemcostdescTblFactory = new RibLocofxitemcostdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxitemcostdescTblFactory; }
  /* constructors */
  public RibLocofxitemcostdescTbl()
  {
    this((RibLocofxitemcostdescRec[])null);
  }

  public RibLocofxitemcostdescTbl(RibLocofxitemcostdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxitemcostdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxitemcostdescTbl a = new RibLocofxitemcostdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxitemcostdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxitemcostdescRec[] getArray() throws SQLException
  {
    return (RibLocofxitemcostdescRec[]) _array.getObjectArray(
      new RibLocofxitemcostdescRec[_array.length()]);
  }

  public RibLocofxitemcostdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxitemcostdescRec[]) _array.getObjectArray(index,
      new RibLocofxitemcostdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxitemcostdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxitemcostdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxitemcostdescRec getElement(long index) throws SQLException
  {
    return (RibLocofxitemcostdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxitemcostdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
