package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxitemctrydescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXItemCtryDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxitemctrydescTbl _RibLocofxitemctrydescTblFactory = new RibLocofxitemctrydescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxitemctrydescTblFactory; }
  /* constructors */
  public RibLocofxitemctrydescTbl()
  {
    this((RibLocofxitemctrydescRec[])null);
  }

  public RibLocofxitemctrydescTbl(RibLocofxitemctrydescRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxitemctrydescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxitemctrydescTbl a = new RibLocofxitemctrydescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxitemctrydescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxitemctrydescRec[] getArray() throws SQLException
  {
    return (RibLocofxitemctrydescRec[]) _array.getObjectArray(
      new RibLocofxitemctrydescRec[_array.length()]);
  }

  public RibLocofxitemctrydescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxitemctrydescRec[]) _array.getObjectArray(index,
      new RibLocofxitemctrydescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxitemctrydescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxitemctrydescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxitemctrydescRec getElement(long index) throws SQLException
  {
    return (RibLocofxitemctrydescRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxitemctrydescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
