package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxitemudadtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXItemUDADtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxitemudadtlTbl _RibLocofxitemudadtlTblFactory = new RibLocofxitemudadtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxitemudadtlTblFactory; }
  /* constructors */
  public RibLocofxitemudadtlTbl()
  {
    this((RibLocofxitemudadtlRec[])null);
  }

  public RibLocofxitemudadtlTbl(RibLocofxitemudadtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxitemudadtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxitemudadtlTbl a = new RibLocofxitemudadtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxitemudadtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxitemudadtlRec[] getArray() throws SQLException
  {
    return (RibLocofxitemudadtlRec[]) _array.getObjectArray(
      new RibLocofxitemudadtlRec[_array.length()]);
  }

  public RibLocofxitemudadtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxitemudadtlRec[]) _array.getObjectArray(index,
      new RibLocofxitemudadtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxitemudadtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxitemudadtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxitemudadtlRec getElement(long index) throws SQLException
  {
    return (RibLocofxitemudadtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxitemudadtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
