package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxtsfdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXTsfDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxtsfdescTbl _RibLocofxtsfdescTblFactory = new RibLocofxtsfdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxtsfdescTblFactory; }
  /* constructors */
  public RibLocofxtsfdescTbl()
  {
    this((RibLocofxtsfdescRec[])null);
  }

  public RibLocofxtsfdescTbl(RibLocofxtsfdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxtsfdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxtsfdescTbl a = new RibLocofxtsfdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxtsfdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxtsfdescRec[] getArray() throws SQLException
  {
    return (RibLocofxtsfdescRec[]) _array.getObjectArray(
      new RibLocofxtsfdescRec[_array.length()]);
  }

  public RibLocofxtsfdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxtsfdescRec[]) _array.getObjectArray(index,
      new RibLocofxtsfdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxtsfdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxtsfdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxtsfdescRec getElement(long index) throws SQLException
  {
    return (RibLocofxtsfdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxtsfdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
