package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXitemcostdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_XItemCostDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXitemcostdescTbl _RibXitemcostdescTblFactory = new RibXitemcostdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemcostdescTblFactory; }
  /* constructors */
  public RibXitemcostdescTbl()
  {
    this((RibXitemcostdescRec[])null);
  }

  public RibXitemcostdescTbl(RibXitemcostdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibXitemcostdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibXitemcostdescTbl a = new RibXitemcostdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXitemcostdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXitemcostdescRec[] getArray() throws SQLException
  {
    return (RibXitemcostdescRec[]) _array.getObjectArray(
      new RibXitemcostdescRec[_array.length()]);
  }

  public RibXitemcostdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXitemcostdescRec[]) _array.getObjectArray(index,
      new RibXitemcostdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXitemcostdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXitemcostdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXitemcostdescRec getElement(long index) throws SQLException
  {
    return (RibXitemcostdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibXitemcostdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
