package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXitemctrydescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_XItemCtryDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXitemctrydescTbl _RibXitemctrydescTblFactory = new RibXitemctrydescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemctrydescTblFactory; }
  /* constructors */
  public RibXitemctrydescTbl()
  {
    this((RibXitemctrydescRec[])null);
  }

  public RibXitemctrydescTbl(RibXitemctrydescRec[] a)
  {
    _array = new MutableArray(2002, a, RibXitemctrydescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibXitemctrydescTbl a = new RibXitemctrydescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXitemctrydescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXitemctrydescRec[] getArray() throws SQLException
  {
    return (RibXitemctrydescRec[]) _array.getObjectArray(
      new RibXitemctrydescRec[_array.length()]);
  }

  public RibXitemctrydescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXitemctrydescRec[]) _array.getObjectArray(index,
      new RibXitemctrydescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXitemctrydescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXitemctrydescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXitemctrydescRec getElement(long index) throws SQLException
  {
    return (RibXitemctrydescRec) _array.getObjectElement(index);
  }

  public void setElement(RibXitemctrydescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
