package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXitemimageTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_XItemImage_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXitemimageTbl _RibXitemimageTblFactory = new RibXitemimageTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemimageTblFactory; }
  /* constructors */
  public RibXitemimageTbl()
  {
    this((RibXitemimageRec[])null);
  }

  public RibXitemimageTbl(RibXitemimageRec[] a)
  {
    _array = new MutableArray(2002, a, RibXitemimageRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibXitemimageTbl a = new RibXitemimageTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXitemimageRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXitemimageRec[] getArray() throws SQLException
  {
    return (RibXitemimageRec[]) _array.getObjectArray(
      new RibXitemimageRec[_array.length()]);
  }

  public RibXitemimageRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXitemimageRec[]) _array.getObjectArray(index,
      new RibXitemimageRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXitemimageRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXitemimageRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXitemimageRec getElement(long index) throws SQLException
  {
    return (RibXitemimageRec) _array.getObjectElement(index);
  }

  public void setElement(RibXitemimageRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
