package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXitemvatdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_XItemVATDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXitemvatdescTbl _RibXitemvatdescTblFactory = new RibXitemvatdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemvatdescTblFactory; }
  /* constructors */
  public RibXitemvatdescTbl()
  {
    this((RibXitemvatdescRec[])null);
  }

  public RibXitemvatdescTbl(RibXitemvatdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibXitemvatdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibXitemvatdescTbl a = new RibXitemvatdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXitemvatdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXitemvatdescRec[] getArray() throws SQLException
  {
    return (RibXitemvatdescRec[]) _array.getObjectArray(
      new RibXitemvatdescRec[_array.length()]);
  }

  public RibXitemvatdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXitemvatdescRec[]) _array.getObjectArray(index,
      new RibXitemvatdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXitemvatdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXitemvatdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXitemvatdescRec getElement(long index) throws SQLException
  {
    return (RibXitemvatdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibXitemvatdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
