package oracle.retail.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofbrxorderdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfBrXOrderDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofbrxorderdtlTbl _RibEofbrxorderdtlTblFactory = new RibEofbrxorderdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofbrxorderdtlTblFactory; }
  /* constructors */
  public RibEofbrxorderdtlTbl()
  {
    this((RibEofbrxorderdtlRec[])null);
  }

  public RibEofbrxorderdtlTbl(RibEofbrxorderdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofbrxorderdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofbrxorderdtlTbl a = new RibEofbrxorderdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofbrxorderdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofbrxorderdtlRec[] getArray() throws SQLException
  {
    return (RibEofbrxorderdtlRec[]) _array.getObjectArray(
      new RibEofbrxorderdtlRec[_array.length()]);
  }

  public RibEofbrxorderdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofbrxorderdtlRec[]) _array.getObjectArray(index,
      new RibEofbrxorderdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofbrxorderdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofbrxorderdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofbrxorderdtlRec getElement(long index) throws SQLException
  {
    return (RibEofbrxorderdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofbrxorderdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
