package oracle.retail.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibLocofxorderdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_LocOfXOrderDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibLocofxorderdtlTbl _RibLocofxorderdtlTblFactory = new RibLocofxorderdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibLocofxorderdtlTblFactory; }
  /* constructors */
  public RibLocofxorderdtlTbl()
  {
    this((RibLocofxorderdtlRec[])null);
  }

  public RibLocofxorderdtlTbl(RibLocofxorderdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibLocofxorderdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibLocofxorderdtlTbl a = new RibLocofxorderdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibLocofxorderdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibLocofxorderdtlRec[] getArray() throws SQLException
  {
    return (RibLocofxorderdtlRec[]) _array.getObjectArray(
      new RibLocofxorderdtlRec[_array.length()]);
  }

  public RibLocofxorderdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibLocofxorderdtlRec[]) _array.getObjectArray(index,
      new RibLocofxorderdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibLocofxorderdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibLocofxorderdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibLocofxorderdtlRec getElement(long index) throws SQLException
  {
    return (RibLocofxorderdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibLocofxorderdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
