package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxitembomdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_ExtOfXItemBOMDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxitembomdescTbl _RibExtofxitembomdescTblFactory = new RibExtofxitembomdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxitembomdescTblFactory; }
  /* constructors */
  public RibExtofxitembomdescTbl()
  {
    this((RibExtofxitembomdescRec[])null);
  }

  public RibExtofxitembomdescTbl(RibExtofxitembomdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxitembomdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__schemaName!=null) return _array.toDatum(c,__schemaName + "." + _SQL_NAME);
    return _array.toDatum(c, _SQL_NAME);
  }
  private String __schemaName = null;
  public void __setSchemaName(String schemaName) { __schemaName = schemaName; }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibExtofxitembomdescTbl a = new RibExtofxitembomdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxitembomdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxitembomdescRec[] getArray() throws SQLException
  {
    return (RibExtofxitembomdescRec[]) _array.getObjectArray(
      new RibExtofxitembomdescRec[_array.length()]);
  }

  public RibExtofxitembomdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxitembomdescRec[]) _array.getObjectArray(index,
      new RibExtofxitembomdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxitembomdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxitembomdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxitembomdescRec getElement(long index) throws SQLException
  {
    return (RibExtofxitembomdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxitembomdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
