/*@lineinfo:filename=RibXitemimageRec*//*@lineinfo:user-code*//*@lineinfo:1^1*/package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.STRUCT;
import oracle.jpub.runtime.MutableStruct;
import sqlj.runtime.ref.DefaultContext;
import sqlj.runtime.ConnectionContext;

public class RibXitemimageRec extends RibObject implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_XItemImage_REC";
  public static final int _SQL_TYPECODE = OracleTypes.STRUCT;

  protected static int[] _sqlType =  { 2,12,12,12,12,12,12,12,12,91,91,12,2003 };
  protected static ORADataFactory[] _factory = new ORADataFactory[13];
  static
  {
    _factory[12] = RibExtofxitemimageTbl.getORADataFactory();
  }
  protected static final RibXitemimageRec _RibXitemimageRecFactory = new RibXitemimageRec();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemimageRecFactory; }
  static
  { _map.put("RIB_XItemImage_REC", _RibXitemimageRecFactory); }

  /* constructors */
  protected void _init_struct(boolean init)
  { if (init) _struct = new MutableStruct(new Object[13], _sqlType, _factory); }
  public RibXitemimageRec()
  { _init_struct(true); __tx = DefaultContext.getDefaultContext(); }
  public RibXitemimageRec(DefaultContext c) /*throws SQLException*/
  { _init_struct(true); __tx = c; }
  public RibXitemimageRec(Connection c) /*throws SQLException*/
  { _init_struct(true); __onn = c; }
  public RibXitemimageRec(java.math.BigDecimal ribOid, String nsVersionV1, String nsNameXitemdesc, String nsTypeBo, String nsLocationBase, String nsLevelNontop, String imageName, String imageAddr, String imageDesc, java.sql.Timestamp createDatetime, java.sql.Timestamp lastUpdateDatetime, String lastUpdateId, RibExtofxitemimageTbl extofxitemimageTbl) throws SQLException
  {
    _init_struct(true);
    setRibOid(ribOid);
    setNsVersionV1(nsVersionV1);
    setNsNameXitemdesc(nsNameXitemdesc);
    setNsTypeBo(nsTypeBo);
    setNsLocationBase(nsLocationBase);
    setNsLevelNontop(nsLevelNontop);
    setImageName(imageName);
    setImageAddr(imageAddr);
    setImageDesc(imageDesc);
    setCreateDatetime(createDatetime);
    setLastUpdateDatetime(lastUpdateDatetime);
    setLastUpdateId(lastUpdateId);
    setExtofxitemimageTbl(extofxitemimageTbl);
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__tx!=null && __onn!=c) release();
    __onn = c;
    return _struct.toDatum(c, _SQL_NAME);
  }


  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  { return create(null, d, sqlType); }
  public void setFrom(RibXitemimageRec o) throws SQLException
  { setContextFrom(o); setValueFrom(o); }
  protected void setContextFrom(RibXitemimageRec o) throws SQLException
  { release(); __tx = o.__tx; __onn = o.__onn; }
  protected void setValueFrom(RibXitemimageRec o) { _struct = o._struct; }
  protected ORAData create(RibXitemimageRec o, Datum d, int sqlType) throws SQLException
  {
    if (d == null) { if (o!=null) { o.release(); }; return null; }
    if (o == null) o = new RibXitemimageRec();
    o._struct = new MutableStruct((STRUCT) d, _sqlType, _factory);
    o.__onn = ((STRUCT) d).getJavaSqlConnection();
    return o;
  }
  protected ORAData createExact(Datum d, int sqlType) throws SQLException
  { return create(null, d, sqlType); }

  /* accessor methods */
  public String getNsVersionV1() throws SQLException
  { return (String) _struct.getAttribute(1); }

  public void setNsVersionV1(String nsVersionV1) throws SQLException
  { _struct.setAttribute(1, nsVersionV1); }


  public String getNsNameXitemdesc() throws SQLException
  { return (String) _struct.getAttribute(2); }

  public void setNsNameXitemdesc(String nsNameXitemdesc) throws SQLException
  { _struct.setAttribute(2, nsNameXitemdesc); }


  public String getNsTypeBo() throws SQLException
  { return (String) _struct.getAttribute(3); }

  public void setNsTypeBo(String nsTypeBo) throws SQLException
  { _struct.setAttribute(3, nsTypeBo); }


  public String getNsLocationBase() throws SQLException
  { return (String) _struct.getAttribute(4); }

  public void setNsLocationBase(String nsLocationBase) throws SQLException
  { _struct.setAttribute(4, nsLocationBase); }


  public String getNsLevelNontop() throws SQLException
  { return (String) _struct.getAttribute(5); }

  public void setNsLevelNontop(String nsLevelNontop) throws SQLException
  { _struct.setAttribute(5, nsLevelNontop); }


  public String getImageName() throws SQLException
  { return (String) _struct.getAttribute(6); }

  public void setImageName(String imageName) throws SQLException
  { _struct.setAttribute(6, imageName); }


  public String getImageAddr() throws SQLException
  { return (String) _struct.getAttribute(7); }

  public void setImageAddr(String imageAddr) throws SQLException
  { _struct.setAttribute(7, imageAddr); }


  public String getImageDesc() throws SQLException
  { return (String) _struct.getAttribute(8); }

  public void setImageDesc(String imageDesc) throws SQLException
  { _struct.setAttribute(8, imageDesc); }


  public java.sql.Timestamp getCreateDatetime() throws SQLException
  { return (java.sql.Timestamp) _struct.getAttribute(9); }

  public void setCreateDatetime(java.sql.Timestamp createDatetime) throws SQLException
  { _struct.setAttribute(9, createDatetime); }


  public java.sql.Timestamp getLastUpdateDatetime() throws SQLException
  { return (java.sql.Timestamp) _struct.getAttribute(10); }

  public void setLastUpdateDatetime(java.sql.Timestamp lastUpdateDatetime) throws SQLException
  { _struct.setAttribute(10, lastUpdateDatetime); }


  public String getLastUpdateId() throws SQLException
  { return (String) _struct.getAttribute(11); }

  public void setLastUpdateId(String lastUpdateId) throws SQLException
  { _struct.setAttribute(11, lastUpdateId); }


  public RibExtofxitemimageTbl getExtofxitemimageTbl() throws SQLException
  { return (RibExtofxitemimageTbl) _struct.getAttribute(12); }

  public void setExtofxitemimageTbl(RibExtofxitemimageTbl extofxitemimageTbl) throws SQLException
  { _struct.setAttribute(12, extofxitemimageTbl); }


  public RibXitemimageRec appendnodevalues (
    String I_PREFIX)
  throws java.sql.SQLException
  {
 try {
    RibXitemimageRec __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:178^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n       :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"0oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_XItemImage_REC"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:183^5*/
    return __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    RibXitemimageRec __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:191^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n       :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"1oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_XItemImage_REC"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:196^5*/
    return __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
  }

  public RibObject appendnodevaluesRS (
    String I_PREFIX)
  throws java.sql.SQLException
  {
 try {
    RibObject __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:211^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        I_PREFIX => :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n      I_PREFIX =>  :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"2oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_OBJECT");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_OBJECT"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibObject)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibObject.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:216^5*/
    return __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    RibObject __jPt_temp = this;
    /*@lineinfo:generated-code*//*@lineinfo:224^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_temp.APPENDNODEVALUES(
//        I_PREFIX => :I_PREFIX);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1 .APPENDNODEVALUES(\n      I_PREFIX =>  :2 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"3oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_OBJECT");
   }
   // set IN parameters
   if (__jPt_temp==null) __sJT_st.setNull(1,2002,"RIB_OBJECT"); else __sJT_st.setORAData(1,__jPt_temp);
   __sJT_st.setString(2,I_PREFIX);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_temp = (oracle.retail.microapps.item.ribtypes.RibObject)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibObject.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:229^5*/
    return __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
  }

  public RibXitemimageRec ribXitemimageRec (
    java.math.BigDecimal RIB_OID,
    String IMAGE_NAME,
    String IMAGE_ADDR,
    String IMAGE_DESC,
    java.sql.Timestamp CREATE_DATETIME,
    java.sql.Timestamp LAST_UPDATE_DATETIME,
    RibXitemimageRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemimageRec __jPt_temp = (RibXitemimageRec) this;
    RibXitemimageRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:251^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemImage_REC(
//        :RIB_OID,
//        :IMAGE_NAME,
//        :IMAGE_ADDR,
//        :IMAGE_DESC,
//        :CREATE_DATETIME,
//        :LAST_UPDATE_DATETIME);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemImage_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"4oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,IMAGE_NAME);
   __sJT_st.setString(4,IMAGE_ADDR);
   __sJT_st.setString(5,IMAGE_DESC);
   __sJT_st.setTimestamp(6,CREATE_DATETIME);
   __sJT_st.setTimestamp(7,LAST_UPDATE_DATETIME);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:261^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:268^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemImage_REC(
//        :RIB_OID,
//        :IMAGE_NAME,
//        :IMAGE_ADDR,
//        :IMAGE_DESC,
//        :CREATE_DATETIME,
//        :LAST_UPDATE_DATETIME);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemImage_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"5oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,IMAGE_NAME);
   __sJT_st.setString(4,IMAGE_ADDR);
   __sJT_st.setString(5,IMAGE_DESC);
   __sJT_st.setTimestamp(6,CREATE_DATETIME);
   __sJT_st.setTimestamp(7,LAST_UPDATE_DATETIME);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:278^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemimageRec ribXitemimageRec (
    java.math.BigDecimal RIB_OID,
    String IMAGE_NAME,
    String IMAGE_ADDR,
    String IMAGE_DESC,
    java.sql.Timestamp CREATE_DATETIME,
    java.sql.Timestamp LAST_UPDATE_DATETIME,
    String LAST_UPDATE_ID,
    RibXitemimageRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemimageRec __jPt_temp = (RibXitemimageRec) this;
    RibXitemimageRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:302^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemImage_REC(
//        :RIB_OID,
//        :IMAGE_NAME,
//        :IMAGE_ADDR,
//        :IMAGE_DESC,
//        :CREATE_DATETIME,
//        :LAST_UPDATE_DATETIME,
//        :LAST_UPDATE_ID);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemImage_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"6oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,IMAGE_NAME);
   __sJT_st.setString(4,IMAGE_ADDR);
   __sJT_st.setString(5,IMAGE_DESC);
   __sJT_st.setTimestamp(6,CREATE_DATETIME);
   __sJT_st.setTimestamp(7,LAST_UPDATE_DATETIME);
   __sJT_st.setString(8,LAST_UPDATE_ID);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:313^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:320^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemImage_REC(
//        :RIB_OID,
//        :IMAGE_NAME,
//        :IMAGE_ADDR,
//        :IMAGE_DESC,
//        :CREATE_DATETIME,
//        :LAST_UPDATE_DATETIME,
//        :LAST_UPDATE_ID);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemImage_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"7oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,IMAGE_NAME);
   __sJT_st.setString(4,IMAGE_ADDR);
   __sJT_st.setString(5,IMAGE_DESC);
   __sJT_st.setTimestamp(6,CREATE_DATETIME);
   __sJT_st.setTimestamp(7,LAST_UPDATE_DATETIME);
   __sJT_st.setString(8,LAST_UPDATE_ID);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:331^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemimageRec ribXitemimageRec (
    java.math.BigDecimal RIB_OID,
    String IMAGE_NAME,
    String IMAGE_ADDR,
    String IMAGE_DESC,
    java.sql.Timestamp CREATE_DATETIME,
    java.sql.Timestamp LAST_UPDATE_DATETIME,
    String LAST_UPDATE_ID,
    RibExtofxitemimageTbl EXTOFXITEMIMAGE_TBL,
    RibXitemimageRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemimageRec __jPt_temp = (RibXitemimageRec) this;
    RibXitemimageRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:356^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemImage_REC(
//        :RIB_OID,
//        :IMAGE_NAME,
//        :IMAGE_ADDR,
//        :IMAGE_DESC,
//        :CREATE_DATETIME,
//        :LAST_UPDATE_DATETIME,
//        :LAST_UPDATE_ID,
//        :EXTOFXITEMIMAGE_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemImage_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"8oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,IMAGE_NAME);
   __sJT_st.setString(4,IMAGE_ADDR);
   __sJT_st.setString(5,IMAGE_DESC);
   __sJT_st.setTimestamp(6,CREATE_DATETIME);
   __sJT_st.setTimestamp(7,LAST_UPDATE_DATETIME);
   __sJT_st.setString(8,LAST_UPDATE_ID);
   if (EXTOFXITEMIMAGE_TBL==null) __sJT_st.setNull(9,2003,"RIB_ExtOfXItemImage_TBL"); else __sJT_st.setORAData(9,EXTOFXITEMIMAGE_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:368^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:375^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemImage_REC(
//        :RIB_OID,
//        :IMAGE_NAME,
//        :IMAGE_ADDR,
//        :IMAGE_DESC,
//        :CREATE_DATETIME,
//        :LAST_UPDATE_DATETIME,
//        :LAST_UPDATE_ID,
//        :EXTOFXITEMIMAGE_TBL);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemImage_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 ,\n       :7 ,\n       :8 ,\n       :9 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"9oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,IMAGE_NAME);
   __sJT_st.setString(4,IMAGE_ADDR);
   __sJT_st.setString(5,IMAGE_DESC);
   __sJT_st.setTimestamp(6,CREATE_DATETIME);
   __sJT_st.setTimestamp(7,LAST_UPDATE_DATETIME);
   __sJT_st.setString(8,LAST_UPDATE_ID);
   if (EXTOFXITEMIMAGE_TBL==null) __sJT_st.setNull(9,2003,"RIB_ExtOfXItemImage_TBL"); else __sJT_st.setORAData(9,EXTOFXITEMIMAGE_TBL);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:387^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemimageRec ribXitemimageRec (
    java.math.BigDecimal RIB_OID,
    String IMAGE_NAME,
    String IMAGE_ADDR,
    String IMAGE_DESC,
    RibXitemimageRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemimageRec __jPt_temp = (RibXitemimageRec) this;
    RibXitemimageRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:408^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemImage_REC(
//        :RIB_OID,
//        :IMAGE_NAME,
//        :IMAGE_ADDR,
//        :IMAGE_DESC);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemImage_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"10oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,IMAGE_NAME);
   __sJT_st.setString(4,IMAGE_ADDR);
   __sJT_st.setString(5,IMAGE_DESC);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:416^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:423^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemImage_REC(
//        :RIB_OID,
//        :IMAGE_NAME,
//        :IMAGE_ADDR,
//        :IMAGE_DESC);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemImage_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"11oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,IMAGE_NAME);
   __sJT_st.setString(4,IMAGE_ADDR);
   __sJT_st.setString(5,IMAGE_DESC);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:431^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }

  public RibXitemimageRec ribXitemimageRec (
    java.math.BigDecimal RIB_OID,
    String IMAGE_NAME,
    String IMAGE_ADDR,
    String IMAGE_DESC,
    java.sql.Timestamp CREATE_DATETIME,
    RibXitemimageRec __jPt_out[])
  throws java.sql.SQLException
  {
    RibXitemimageRec __jPt_temp = (RibXitemimageRec) this;
    RibXitemimageRec __jPt_result;
 try {
    /*@lineinfo:generated-code*//*@lineinfo:453^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemImage_REC(
//        :RIB_OID,
//        :IMAGE_NAME,
//        :IMAGE_ADDR,
//        :IMAGE_DESC,
//        :CREATE_DATETIME);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemImage_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"12oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,IMAGE_NAME);
   __sJT_st.setString(4,IMAGE_ADDR);
   __sJT_st.setString(5,IMAGE_DESC);
   __sJT_st.setTimestamp(6,CREATE_DATETIME);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:462^5*/
    __jPt_out[0] = __jPt_temp;
 } catch(java.sql.SQLException _err) {
   try {
      getConnectionContext().getExecutionContext().close();
      closeConnection();
      if (__dataSource==null) throw _err;
    /*@lineinfo:generated-code*//*@lineinfo:469^5*/

//  ************************************************************
//  #sql [getConnectionContext()] { BEGIN
//        :__jPt_result := RIB_XItemImage_REC(
//        :RIB_OID,
//        :IMAGE_NAME,
//        :IMAGE_ADDR,
//        :IMAGE_DESC,
//        :CREATE_DATETIME);
//        END;
//       };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OracleCallableStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = getConnectionContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "BEGIN\n       :1  := RIB_XItemImage_REC(\n       :2 ,\n       :3 ,\n       :4 ,\n       :5 ,\n       :6 );\n      END;";
   __sJT_st = __sJT_ec.prepareOracleCall(__sJT_cc,"13oracle.retail.merch20.microApps.createRegItem.RibXitemimageRec",theSqlTS);
   if (__sJT_ec.isNew())
   {
      __sJT_st.registerOutParameter(1,2002,"RIB_XItemImage_REC");
   }
   // set IN parameters
   __sJT_st.setBigDecimal(2,RIB_OID);
   __sJT_st.setString(3,IMAGE_NAME);
   __sJT_st.setString(4,IMAGE_ADDR);
   __sJT_st.setString(5,IMAGE_DESC);
   __sJT_st.setTimestamp(6,CREATE_DATETIME);
  // execute statement
   __sJT_ec.oracleExecuteUpdate();
   // retrieve OUT parameters
   __jPt_result = (oracle.retail.microapps.item.ribtypes.RibXitemimageRec)__sJT_st.getORAData(1, oracle.retail.microapps.item.ribtypes.RibXitemimageRec.getORADataFactory());
  } finally { __sJT_ec.oracleClose(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:478^5*/
    __jPt_out[0] = __jPt_temp;
   } catch (java.sql.SQLException _err2) {
     try { getConnectionContext().getExecutionContext().close(); } catch (java.sql.SQLException _sqle) {}
     throw _err;
  }
 }
    return __jPt_result;
  }
}/*@lineinfo:generated-code*/