package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibXitemimageRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RIB_XItemImage_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibXitemimageRecRef _RibXitemimageRecRefFactory = new RibXitemimageRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemimageRecRefFactory; }
  /* constructor */
  public RibXitemimageRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibXitemimageRecRef r = new RibXitemimageRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibXitemimageRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibXitemimageRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibXitemimageRecRef: "+exn.toString()); }
  }

  public RibXitemimageRec getValue() throws SQLException
  {
     return (RibXitemimageRec)RibXitemimageRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibXitemimageRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
