package oracle.retail.microapps.item.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibXitemsupctydescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RIB_XItemSupCtyDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibXitemsupctydescTbl _RibXitemsupctydescTblFactory = new RibXitemsupctydescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibXitemsupctydescTblFactory; }
  /* constructors */
  public RibXitemsupctydescTbl()
  {
    this((RibXitemsupctydescRec[])null);
  }

  public RibXitemsupctydescTbl(RibXitemsupctydescRec[] a)
  {
    _array = new MutableArray(2002, a, RibXitemsupctydescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    if (__schemaName!=null) return _array.toDatum(c,__schemaName + "." + _SQL_NAME);
    return _array.toDatum(c, _SQL_NAME);
  }
  private String __schemaName = null;
  public void __setSchemaName(String schemaName) { __schemaName = schemaName; }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    RibXitemsupctydescTbl a = new RibXitemsupctydescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibXitemsupctydescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibXitemsupctydescRec[] getArray() throws SQLException
  {
    return (RibXitemsupctydescRec[]) _array.getObjectArray(
      new RibXitemsupctydescRec[_array.length()]);
  }

  public RibXitemsupctydescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibXitemsupctydescRec[]) _array.getObjectArray(index,
      new RibXitemsupctydescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibXitemsupctydescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibXitemsupctydescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibXitemsupctydescRec getElement(long index) throws SQLException
  {
    return (RibXitemsupctydescRec) _array.getObjectElement(index);
  }

  public void setElement(RibXitemsupctydescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
