package oracle.retail.microapps.order.create.managed;

import java.util.ArrayList;
import java.util.Collection;

import org.apache.myfaces.trinidad.model.SortableModel;

public class OrderItemQtyTableModel extends SortableModel  {
  
  private Collection <OrderItemQtyRow> itemCollection;
  
  public OrderItemQtyTableModel() {
      itemCollection = new ArrayList<OrderItemQtyRow>();
      setWrappedData(itemCollection);
  }
  
  /**
    * This method adds the row to the itemCollection.
    * @param row
    */
  public void addRow (OrderItemQtyRow row){
      ((ArrayList)getWrappedData()).add(row);
  }
  
  public void setItemCollection(Collection<OrderItemQtyRow> itemCollection) {
      this.itemCollection = itemCollection;
  }
  
  public Collection<OrderItemQtyRow> getItemCollection() {
      return itemCollection;
  }
}
