package oracle.retail.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxorderdtlTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_ExtOfXOrderDtl_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxorderdtlTbl _RibExtofxorderdtlTblFactory = new RibExtofxorderdtlTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxorderdtlTblFactory; }
  /* constructors */
  public RibExtofxorderdtlTbl()
  {
    this((RibExtofxorderdtlRec[])null);
  }

  public RibExtofxorderdtlTbl(RibExtofxorderdtlRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxorderdtlRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibExtofxorderdtlTbl a = new RibExtofxorderdtlTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxorderdtlRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxorderdtlRec[] getArray() throws SQLException
  {
    return (RibExtofxorderdtlRec[]) _array.getObjectArray(
      new RibExtofxorderdtlRec[_array.length()]);
  }

  public RibExtofxorderdtlRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxorderdtlRec[]) _array.getObjectArray(index,
      new RibExtofxorderdtlRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxorderdtlRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxorderdtlRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxorderdtlRec getElement(long index) throws SQLException
  {
    return (RibExtofxorderdtlRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxorderdtlRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
