package oracle.retail.microapps.item.create.am;

import oracle.retail.microapps.item.create.am.applicationModule.CreateItemAMFixture;
import oracle.retail.microapps.item.create.am.applicationModule.CreateItemAMTest;
import oracle.retail.microapps.item.create.am.view.ClassVO1VO.ClassVO1VOTest;
import oracle.retail.microapps.item.create.am.view.CostZoneGroupVO1VO.CostZoneGroupVO1VOTest;
import oracle.retail.microapps.item.create.am.view.CountryVO1VO.CountryVO1VOTest;
import oracle.retail.microapps.item.create.am.view.DepartmentVO1VO.DepartmentVO1VOTest;
import oracle.retail.microapps.item.create.am.view.ItemNumberTypeVO1VO.ItemNumberTypeVO1VOTest;
import oracle.retail.microapps.item.create.am.view.RetailPriceZoneGroupVO1VO.RetailPriceZoneGroupVO1VOTest;
import oracle.retail.microapps.item.create.am.view.StandardUomVO1VO.StandardUomVO1VOTest;
import oracle.retail.microapps.item.create.am.view.SubclassVO1VO.SubclassVO1VOTest;
import oracle.retail.microapps.item.create.am.view.SupplierSiteVO1VO.SupplierSiteVO1VOTest;
import oracle.retail.microapps.item.create.am.view.SupplierVO1VO.SupplierVO1VOTest;
import oracle.retail.microapps.item.create.am.view.SystemOptionsVO1VO.SystemOptionsVO1VOTest;

import org.junit.*;
import org.junit.runner.RunWith;
import org.junit.runners.Suite;

@RunWith(Suite.class)
@Suite.SuiteClasses( { SystemOptionsVO1VOTest.class,
                       StandardUomVO1VOTest.class,
                       RetailPriceZoneGroupVO1VOTest.class,
                       CostZoneGroupVO1VOTest.class,
                       ItemNumberTypeVO1VOTest.class, SupplierVO1VOTest.class,
                       SupplierSiteVO1VOTest.class, SubclassVO1VOTest.class,
                       DepartmentVO1VOTest.class, CountryVO1VOTest.class,
                       ClassVO1VOTest.class, CreateItemAMTest.class })
public class AllCreateItemTests {
    @BeforeClass
    public static void setUp() {
    }

    @AfterClass
    public static void tearDown() throws Exception {
        CreateItemAMFixture.getInstance().release();
    }
}
