package oracle.retail.microapps.order.cancel.am.view.OrdersVO1VO;

import oracle.jbo.Row;
import oracle.jbo.ViewObject;

import oracle.retail.microapps.order.cancel.am.applicationModule.CancelOrderAMFixture;

import org.apache.log4j.Logger;

import org.junit.*;
import static org.junit.Assert.*;

public class OrdersVO1VOTest {
    private CancelOrderAMFixture fixture1 = CancelOrderAMFixture.getInstance();
    // get a logger instance
    Logger logger = Logger.getLogger(OrdersVO1VOTest.class);
  
    public OrdersVO1VOTest() {
    }

    @Test
    public void testAccess() {
        ViewObject view = fixture1.getApplicationModule().findViewObject("SelectOrderVO1");
        assertNotNull(view);
    }
    
    /**
    * This method is to test the View Objects for the valid data.
    * Expected Result : Row with valid data found in database
    */
    @Test
    public void testValidData() {
        ViewObject view = fixture1.getApplicationModule().findViewObject("SelectOrderVO1");
        logger.debug("SelectOrderVO1 VO fetched");
        view.executeQuery();
        Row r = view.first();
        Row r2 = view.next();
        Object[] obj = r2.getAttributeValues();
        logger.debug("No of Columns received :  " + obj.length + "  Data received --> " + " " + obj[0]+ " " + obj[1] + " " + obj[2] + " " + obj[3]);
        assertNotNull(obj);
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }
}
