package oracle.training.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibEofinxorderdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_EOfInXOrderDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibEofinxorderdescTbl _RibEofinxorderdescTblFactory = new RibEofinxorderdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibEofinxorderdescTblFactory; }
  /* constructors */
  public RibEofinxorderdescTbl()
  {
    this((RibEofinxorderdescRec[])null);
  }

  public RibEofinxorderdescTbl(RibEofinxorderdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibEofinxorderdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibEofinxorderdescTbl a = new RibEofinxorderdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibEofinxorderdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibEofinxorderdescRec[] getArray() throws SQLException
  {
    return (RibEofinxorderdescRec[]) _array.getObjectArray(
      new RibEofinxorderdescRec[_array.length()]);
  }

  public RibEofinxorderdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibEofinxorderdescRec[]) _array.getObjectArray(index,
      new RibEofinxorderdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibEofinxorderdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibEofinxorderdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibEofinxorderdescRec getElement(long index) throws SQLException
  {
    return (RibEofinxorderdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibEofinxorderdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
