package oracle.training.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class RibExtofxorderdescTbl implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "RMS01.RIB_ExtOfXOrderDesc_TBL";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final RibExtofxorderdescTbl _RibExtofxorderdescTblFactory = new RibExtofxorderdescTbl();

  public static ORADataFactory getORADataFactory()
  { return _RibExtofxorderdescTblFactory; }
  /* constructors */
  public RibExtofxorderdescTbl()
  {
    this((RibExtofxorderdescRec[])null);
  }

  public RibExtofxorderdescTbl(RibExtofxorderdescRec[] a)
  {
    _array = new MutableArray(2002, a, RibExtofxorderdescRec.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibExtofxorderdescTbl a = new RibExtofxorderdescTbl();
    a._array = new MutableArray(2002, (ARRAY) d, RibExtofxorderdescRec.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public RibExtofxorderdescRec[] getArray() throws SQLException
  {
    return (RibExtofxorderdescRec[]) _array.getObjectArray(
      new RibExtofxorderdescRec[_array.length()]);
  }

  public RibExtofxorderdescRec[] getArray(long index, int count) throws SQLException
  {
    return (RibExtofxorderdescRec[]) _array.getObjectArray(index,
      new RibExtofxorderdescRec[_array.sliceLength(index, count)]);
  }

  public void setArray(RibExtofxorderdescRec[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(RibExtofxorderdescRec[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public RibExtofxorderdescRec getElement(long index) throws SQLException
  {
    return (RibExtofxorderdescRec) _array.getObjectElement(index);
  }

  public void setElement(RibExtofxorderdescRec a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
