package oracle.training.microapps.order.ribtypes;

import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class RibInxorderdtlRecRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "RMS01.RIB_InXOrderDtl_REC";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

private static final RibInxorderdtlRecRef _RibInxorderdtlRecRefFactory = new RibInxorderdtlRecRef();

  public static ORADataFactory getORADataFactory()
  { return _RibInxorderdtlRecRefFactory; }
  /* constructor */
  public RibInxorderdtlRecRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    RibInxorderdtlRecRef r = new RibInxorderdtlRecRef();
    r._ref = (REF) d;
    return r;
  }

  public static RibInxorderdtlRecRef cast(ORAData o) throws SQLException
  {
     if (o == null) return null;
     try { return (RibInxorderdtlRecRef) getORADataFactory().create(o.toDatum(null), OracleTypes.REF); }
     catch (Exception exn)
     { throw new SQLException("Unable to convert "+o.getClass().getName()+" to RibInxorderdtlRecRef: "+exn.toString()); }
  }

  public RibInxorderdtlRec getValue() throws SQLException
  {
     return (RibInxorderdtlRec) RibInxorderdtlRec.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(RibInxorderdtlRec c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
