package oracle.training.microapps.order.modify.am.view.OrderDetailsVO1VO;

import oracle.jbo.Row;
import oracle.jbo.ViewObject;

import oracle.training.microapps.order.modify.am.applicationModule.ModifyOrderAMFixture;

import oracle.training.microapps.order.modify.am.view.OrdersVO1VO.OrdersVO1VOTest;

import org.apache.log4j.Logger;

import org.junit.*;
import static org.junit.Assert.*;

public class OrderDetailsVO1VOTest {
  // get a logger instance
  Logger logger = Logger.getLogger(OrderDetailsVO1VOTest.class);
    private ModifyOrderAMFixture fixture1 = ModifyOrderAMFixture.getInstance();

    public OrderDetailsVO1VOTest() {
    }

    @Test
    public void testAccess() {
        ViewObject view = fixture1.getApplicationModule().findViewObject("OrderDetailsVO1");
        assertNotNull(view);
    }
  @Test
  public void testExecuteQueryWithValidData() {
      ViewObject view1 =
          fixture1.getApplicationModule().findViewObject("OrdersVO1");
      Object x="A";
    view1.setNamedWhereClauseParam("statusID",x);
    view1.executeQuery();
    Row first1 = view1.first();
    Object[] obj = first1.getAttributeValues();
    logger.debug("No of Columns received :  " + obj.length + "  Data received --> " + " " + obj[0]+ " " + obj[1] + " " + obj[2] + " " + obj[3]);
      logger.debug("OrdersVO1 VO fetched");
    Object orderNo=first1.getAttribute("OrderNo");
    ViewObject view2 =
        fixture1.getApplicationModule().findViewObject("OrderDetailsVO1");
    view2.setNamedWhereClauseParam("order_no",orderNo);
    view2.executeQuery();
    Row first2 = view2.first();
    Object[] obj2 = first2.getAttributeValues();
    logger.debug("No of Columns received :  " + obj2.length + "  Data received --> " + " " + obj2[0]+ " " + obj2[1] + " " + obj2[2] + " " + obj[3]);
    assertNotNull(obj);
    assertNotNull(obj2);
      
  }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }
}
