package oracle.training.microapps.order.modify.am.view.OrdersVO1VO;

import oracle.jbo.Row;
import oracle.jbo.ViewObject;

import oracle.jbo.domain.Number;

import oracle.training.microapps.order.modify.am.applicationModule.ModifyOrderAMFixture;

import org.apache.log4j.Logger;

import org.junit.*;
import static org.junit.Assert.*;

public class OrdersVO1VOTest {
  // get a logger instance
  Logger logger = Logger.getLogger(OrdersVO1VOTest.class);
    private ModifyOrderAMFixture fixture1 = ModifyOrderAMFixture.getInstance();

    public OrdersVO1VOTest() {
    }

    @Test
    public void testAccess() {
        ViewObject view = fixture1.getApplicationModule().findViewObject("OrdersVO1");
        assertNotNull(view);
    }
  @Test
  public void testExecuteQueryWithValidData() {
      ViewObject view1 =
          fixture1.getApplicationModule().findViewObject("OrdersVO1");
      Object x="A";
    view1.setNamedWhereClauseParam("statusID",x);
    view1.executeQuery();
    Row first1 = view1.first();
    Object[] obj = first1.getAttributeValues();
    logger.debug("No of Columns received :  " + obj.length + "  Data received --> " + " " + obj[0]+ " " + obj[1] + " " + obj[2] + " " + obj[3]);
      logger.debug("OrdersVO1 VO fetched");
    assertNotNull(obj);
  }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }
}
